﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Collections;
using System.Windows.Forms;

namespace AkaneMail
{
    public partial class Form3 : Form
    {
        public DialogResult resultSendMail;
        public bool directSendFlag;
        public bool reMailFlag;
        public string reAddress;
        public string reSubject;
        public string reBody;
        public string attachName;

        public Form3()
        {
            InitializeComponent();
            resultSendMail = DialogResult.Cancel;
        }

        private void Form3_Resize(object sender, EventArgs e)
        {
            textAddress.Width = this.Width - 75;
            textSubject.Width = this.Width - 75;
        }

        private void menuFileClose_Click(object sender, EventArgs e)
        {
            resultSendMail = DialogResult.Cancel;
            this.Close();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            resultSendMail = DialogResult.Cancel;
            this.Close();
        }

        private void Form3_Load(object sender, EventArgs e)
        {
            // 直接送信フラグをfalseに変更
            directSendFlag = false;
            attachName = "";

            if(reMailFlag == true){
                this.textAddress.Text = reAddress;
                this.textSubject.Text = reSubject;
                this.textBody.Text = reBody;
                reMailFlag = false;
            }
        }

        private void menuFileDirectSend_Click(object sender, EventArgs e)
        {
            string attachList = "";

            // アドレスと本文がない場合はキャンセル扱いにする
            if(textAddress.Text != "" && textBody.Text != ""){
                directSendFlag = true;
                resultSendMail = DialogResult.OK;
                if(textSubject.Text == ""){
                    textSubject.Text = "(無題)";
                }

                // 添付ファイルが１個以上ある場合
                if(buttonAttachList.DropDownItems.Count > 1){
                    for(int cnt = 0; cnt < buttonAttachList.DropDownItems.Count; cnt++){
                        // 添付ファイルが１個の場合(添付ファイルが複数ある場合の１回目)
                        if(cnt == 0){
                            attachList = buttonAttachList.DropDownItems[cnt].Text;
                        }
                        else{
                            // ２個以上の添付ファイルがある場合、カンマ区切りで
                            attachList = attachList + "," + buttonAttachList.DropDownItems[cnt].Text;
                        }
                    }
                    // 添付ファイル名のリストを変数に渡す
                    attachName = attachList;
                }
            }
            else{
                resultSendMail = DialogResult.Cancel;
            }

            this.Close(); 
        }

        private void menuFileAttach_Click(object sender, EventArgs e)
        {
            Icon appIcon;

            // ファイルを開くダイアログを表示する
            if(openFileDialog1.ShowDialog() == DialogResult.OK){
                if(openFileDialog1.FileName != ""){
                    buttonAttachList.Visible = true;
                    labelMessage.Text = openFileDialog1.FileName + "をメールに添付しました。";
                    appIcon = System.Drawing.Icon.ExtractAssociatedIcon(openFileDialog1.FileName);
                    buttonAttachList.DropDownItems.Add(openFileDialog1.FileName, appIcon.ToBitmap());
                }
            }
        }

        private void menuEditUndo_Click(object sender, EventArgs e)
        {
            if(this.textBody.CanUndo){
                this.textBody.Undo();
                this.textBody.ClearUndo();
            }
        }

        private void menuEditCut_Click(object sender, EventArgs e)
        {
            if(this.textBody.SelectionLength > 0){
                this.textBody.Cut();
            }
        }

        private void menuEditCopy_Click(object sender, EventArgs e)
        {
            if(this.textBody.SelectionLength > 0){
                this.textBody.Copy();
            }
        }

        private void menuEditPaste_Click(object sender, EventArgs e)
        {
            if(Clipboard.ContainsData(DataFormats.Text)){
                this.textBody.Paste();
            }
        }

        private void menuEditAllSelect_Click(object sender, EventArgs e)
        {
            this.textBody.SelectAll();
        }

        private void menuEditDelete_Click(object sender, EventArgs e)
        {
            if(this.textBody.SelectionLength > 0){
                this.textBody.SelectedText = "";
            }
        }

        private void menuEdit_Click(object sender, EventArgs e)
        {
            if(this.textBody.CanUndo == true){
                this.menuEditUndo.Enabled = true;
            }
            else{
                this.menuEditUndo.Enabled = false;
            }

            if(Clipboard.ContainsData(DataFormats.Text)){
                this.menuEditCopy.Enabled = true;
            }
            else{
                this.menuEditCopy.Enabled = false;
            }

            if(this.textBody.Text.Length > 0){
                this.menuEditAllSelect.Enabled = true;
            }
            else{
                this.menuEditAllSelect.Enabled = false;
            }

            if(this.textBody.SelectionLength > 0){
                this.menuEditCut.Enabled = true;
                this.menuEditCopy.Enabled = true;
                this.menuEditDelete.Enabled = true;
            }
            else{
                this.menuEditCut.Enabled = false;
                this.menuEditCopy.Enabled = false;
                this.menuEditDelete.Enabled = false;
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if(this.textBody.SelectionLength > 0){
                this.buttonCut.Enabled = true;
                this.buttonCopy.Enabled = true;
            }
            else{
                this.buttonCut.Enabled = false;
                this.buttonCopy.Enabled = false;
            }
            
            if(Clipboard.ContainsData(DataFormats.Text)){
                this.buttonPaste.Enabled = true;
            }
            else{
                this.buttonPaste.Enabled = false;
            }
        }

        private void menuFileSend_Click(object sender, EventArgs e)
        {
            string attachList = "";

            // アドレスと本文がない場合はキャンセル扱いにする
            if(textAddress.Text != "" && textBody.Text != ""){
                resultSendMail = DialogResult.OK;
                if(textSubject.Text == ""){
                    textSubject.Text = "(無題)";
                }

                // 添付ファイルが１個以上ある場合
                if(buttonAttachList.DropDownItems.Count > 1){
                    for(int cnt = 0; cnt < buttonAttachList.DropDownItems.Count; cnt++){
                        // 添付ファイルが１個の場合(添付ファイルが複数ある場合の１回目)
                        if(cnt == 0){
                            attachList = buttonAttachList.DropDownItems[cnt].Text;
                        }
                        else{
                            // ２個以上の添付ファイルがある場合、カンマ区切りで
                            attachList = attachList + "," + buttonAttachList.DropDownItems[cnt].Text;
                        }
                    }
                    // 添付ファイル名のリストを変数に渡す
                    attachName = attachList;
                }
            }
            else{
                resultSendMail = DialogResult.Cancel;
            }

            this.Close();
        }

    }
}