using System;
using System.Text;
using System.Runtime.InteropServices;
using System.Collections;
using System.Collections.Specialized;
using System.Net.Sockets;
using System.IO;
using System.Runtime.Serialization;

namespace nMail
{
	/// <summary>
	/// nMail.DLL G[ԂĂꍇɔO
	/// </summary>
	public class nMailException: ApplicationException, ISerializable
	{
		int _error_code;
		/// <summary>
		/// G[bZ[WƃG[R[hw肵āA<c>nMailException</c>NX̐VCX^X܂B
		/// </summary>
		/// <param name="message"></param>
		/// <param name="error_code"></param>
		public nMailException(string message, int error_code): base(message)
		{
			this._error_code = error_code;
		}
		/// <summary>
		/// VAf[^w肵āA<c>nMailException</c>NX̐VCX^X܂B
		/// </summary>
		/// <param name="info"></param>
		/// <param name="context"></param>
		public nMailException(SerializationInfo info, StreamingContext context): base(info, context)
		{
			_error_code = info.GetInt32("ErrorCode");
		}
		/// <summary>
		/// G[R[hłB
		/// </summary>
		public int ErrorCode
		{
			get
			{
				return _error_code;
			}
		}
		/// <summary>
		/// T[o[ԂꂽG[bZ[WłB
		/// </summary>
		public override string Message
		{
			get
			{
				return base.Message;
			}
		}
		/// <summary>
		/// OɊւgp SerializationInfo ݒ肵܂B
		/// </summary>
		/// <param name="info"></param>
		/// <param name="context"></param>
		public override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
			info.AddValue("ErrorCode", _error_code);
		}
	}

	/// <summary>
	/// Winsock ֘ANX
	/// </summary>
	public class Winsock
	{
		/// <summary>
		/// <c>Winsock</c>NX̐VKCX^X܂B
		/// </summary>
		public Winsock()
		{
		}
		/// <summary>
		/// Winsock ܂B
		/// </summary>
		[DllImport("nMail.DLL", EntryPoint="NMailInitializeWinSock")]
		public static extern bool Initialize();

		/// <summary>
		/// Winsock ̎gpI܂B
		/// </summary>
		[DllImport("nMail.DLL", EntryPoint="NMailEndWinSock")]
		public static extern bool Done();
	}
	/// <summary>
	/// POP3[MNX
	/// </summary>
	/// <remarks>
	/// <example>
	/// <para>
	/// w̃[ԍ(ϐ:no)擾AƖ{\B
	/// <code lang="cs">
	///	using(nMail.Pop3 pop = new nMail.Pop3("mail.example.com")) {
	///		try {
	///			pop.Connect();
	///			pop.Authenticate("pop3_id", "password");
	///			pop.GetMail(no);
	///			MessageBox.Show(String.Format("[ԍ:{0:d} :{1:s}\r\n{2:s}", no, pop.Subject, pop.Body));
	///		}
	///		catch(nMail.nMailException nex)
	///		{
	///			MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message));
	///		}
	///		catch(Exception ex)
	///		{
	///			MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message));
	///		}
	///	}
	/// </code>
	/// <code lang="vbnet">
	///	' VB.NET 2005 ȍ~̏ꍇAC# Ɠl using gpł܂B
	/// Dim pop As nMail.Pop3 = New nMail.Pop3("mail.example.com")
	/// Try
	/// 	pop.Connect()
	/// 	pop.Authenticate("pop3_id", "password")
	///		pop.GetMail(no)
	///		MessageBox.Show(String.Format("[ԍ:{0:d} :{1:s}" + ControlChars.CrLf + "{2:s}", no, pop.Subject, pop.Body))
	///	Catch nex As nMail.nMailException
	///		MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message))
	///	Catch ex As Exception
	///		MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message))
	///	Finally
	///		pop.Dispose()
	///	End Try
	/// </code>
	/// </para>
	/// <para>
	/// w̃[ԍ(ϐ:no)擾AƖ{\BYtt@C z:\temp ɕۑB
	/// <code lang="cs">
	///	using(nMail.Pop3 pop = new nMail.Pop3("mail.example.com")) {
	///		try {
	///			pop.Connect();
	///			pop.Authenticate("pop3_id", "password");
	///			pop.Path = @"z:\temp";
	///			pop.GetMail(no);
	///			MessageBox.Show(String.Format("[ԍ:{0:d} :{1:s}\r\n{2:s}", no, pop.Subject, pop.Body));
	///			if(pop.FileNameList == null)
	///			{
	///				MessageBox.Show("t@C͂܂");
	///			}
	///			else
	///			{
	///				for(int fno = 0 ; fno &lt; pop.FileNameList.Length ; fno++) 
	///				{
	///					MessageBox.Show(String.Format("Ytt@C:{0:s}", pop.FileNameList[fno]));
	///				}
	///			}
	///		}
	///		catch(nMail.nMailException nex)
	///		{
	///			MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message));
	///		}
	///		catch(Exception ex)
	///		{
	///			MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message));
	///		}
	///	}
	/// </code>
	/// <code lang="vbnet">
	///	' VB.NET 2005 ȍ~̏ꍇAC# Ɠl using gpł܂B
	/// Dim pop As nMail.Pop3 = New nMail.Pop3("mail.example.com")
	/// Try
	/// 	pop.Connect()
	/// 	pop.Authenticate("pop3_id", "password")
	///		pop.Path = "z:\temp"
	///		pop.GetMail(no)
	///		MessageBox.Show(String.Format("[ԍ:{0:d} :{1:s}" + ControlChars.CrLf + "{2:s}", no, pop.Subject, pop.Body))
	///		If pop.FileNameList Is Nothing Then
	///			MessageBox.Show("t@C͂܂")
	///		Else
	///			Dim fno As Integer
	///			For fno = 0 To pop.FileNameList.Length - 1
	///				MessageBox.Show(String.Format("Ytt@C:{0:s}", pop.FileNameList(fno)))
	///			Next fno
	///		End If
	///	Catch nex As nMail.nMailException
	///		MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message))
	///	Catch ex As Exception
	///		MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message))
	///	Finally
	///		pop.Dispose()
	///	End Try
	/// </code>
	/// </para>
	/// <para>
	///	ꎞx~@\gĎw̃[ԍ(ϐ:no)擾AƖ{\BYtt@C z:\temp ɕۑB
	/// <code lang="cs">
	///	using(nMail.Pop3 pop = new nMail.Pop3("mail.example.com")) {
	///		try {
	///			pop.Connect();
	///			pop.Authenticate("pop3_id", "password");
	///			// ̋x~񐔂𓾂
	///			int count = pop.GetSize(no) / (nMail.Options.SuspendSize * 1024) + 1;
	///			pop.Path = @"z:\temp";
	///			pop.GetMail(no);
	///			pop.Flag = nMail.Pop3.SuspendAttachmentFile;
	///			pop.GetMail(no);
	///			pop.Flag = nMail.Pop3.SuspendNext;
	///			while(pop.ErrorCode == nMail.Pop3.ErrorSuspendAttachmentFile)
	///			{
	///				pop.GetMail(no);
	///				// vOXo[i߂铙̏
	///				Application.DoEvents();
	///			}
	///			MessageBox.Show(String.Format("[ԍ:{0:d} :{1:s}\r\n{2:s}", no, pop.Subject, pop.Body));
	///			if(pop.FileNameList == null)
	///			{
	///				MessageBox.Show("t@C͂܂");
	///			}
	///			else
	///			{
	///				for(int fno = 0 ; fno &lt; pop.FileNameList.Length ; fno++) 
	///				{
	///					MessageBox.Show(String.Format("Ytt@C:{0:s}", pop.FileNameList[fno]));
	///				}
	///			}
	///		}
	///		catch(nMail.nMailException nex)
	///		{
	///			MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message));
	///		}
	///		catch(Exception ex)
	///		{
	///			MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message));
	///		}
	///	}
	/// </code>
	/// <code lang="vbnet">
	///	' VB.NET 2005 ȍ~̏ꍇAC# Ɠl using gpł܂B
	///	Dim pop As nMail.Pop3 = New nMail.Pop3("mail.example.com")
	///	Try
	///		Dim count As Integer
	///
	///		pop.Connect()
	///		pop.Authenticate("pop3_id", "password")
	///		' ̋x~񐔂𓾂
	///		count = pop.GetSize(no) \ (nMail.Options.SuspendSize * 1024) + 1
	///		pop.Path = "z:\temp"
	///		pop.Flag = nMail.Pop3.SuspendAttachmentFile
	///		pop.GetMail(no)
	///		pop.Flag = nMail.Pop3.SuspendNext
	///		Do While pop.ErrorCode = nMail.Pop3.ErrorSuspendAttachmentFile
	///			pop.GetMail(no)
	///			' vOXo[i߂铙̏
	///			Application.DoEvents()
	///		Loop
	///		MessageBox.Show(String.Format("[ԍ:{0:d} :{1:s}" + ControlChars.CrLf + "{2:s}", no, pop.Subject, pop.Body))
	///		If pop.FileNameList Is Nothing Then
	///			MessageBox.Show("t@C͂܂")
	///		Else
	///			Dim fno As Integer
	///			For fno = 0 To pop.FileNameList.Length - 1
	///				MessageBox.Show(String.Format("Ytt@C:{0:s}", pop.FileNameList(fno)))
	///			Next fno
	///		End If
	///	Catch nex As nMail.nMailException
	///		MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message))
	///	Catch ex As Exception
	///		MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message))
	///	Finally
	///		pop.Dispose()
	///	End Try
	/// </code>
	/// </para>
	/// </example>
	/// </remarks>
	public class Pop3 : IDisposable
	{
		/// <summary>
		/// wb_̈̃TCYłB
		/// </summary>
		protected const int HeaderSize = 32768;
		/// <summary>
		/// pX̃TCYłB
		/// </summary>
		protected const int MaxPath = 32768;
		/// <summary>
		/// g@\pobt@TCYłB
		/// </summary>
		protected const int AttachmentTempSize = 400;
		/// <summary>
		/// \PbgG[͖ڑԂłB
		/// </summary>
		/// <remarks>
		/// <para><see cref="Connect"/>Ăяo<see cref="GetMail"/>A</para>
		/// <para>ĂяoAȂ炩̗RŐڑؒfƂ̃G[ƂȂ܂B</para>
		/// <para><see cref="nMailException.ErrorCode"/>ɐݒ肳܂B</para>
		/// </remarks>
		public const int ErrorSocket = -1;
		/// <summary>
		/// F؃G[łB
		/// </summary>
		/// <remarks>
		/// <para><see cref="Authenticate"/>ĂяoŔF؂Ɏsꍇ</para>
		/// <para>̃G[ƂȂ܂B</para>
		/// <para><see cref="nMailException.ErrorCode"/>ɐݒ肳܂B</para>
		/// </remarks>
		public const int ErrorAuthenticate = -2;
		/// <summary>
		/// ԍŎw肳ꂽ[݂܂B
		/// </summary>
		/// <remarks>
		/// <para><see cref="GetMail"/>Ŏw肵ԍ̃[݂ȂƂ̃G[ƂȂ܂B</para>
		/// <para><see cref="nMailException.ErrorCode"/>ɐݒ肳܂B</para>
		/// </remarks>
		public const int ErrorInvalidNo = -3;
		/// <summary>
		/// ^CAEgG[łB
		/// </summary>
		/// <remarks>
		/// <para><see cref="Options.Timeout"/>Ŏw肵l蒷ԃT[o牞</para>
		/// <para>ȂꍇÃG[܂B</para>
		/// <para><see cref="nMailException.ErrorCode"/>ɐݒ肳܂B</para>
		/// </remarks>
		public const int ErrorTimeout = -4;
		/// <summary>
		/// Ytt@CJ܂B
		/// </summary>
		/// <remarks>
		/// <para><see cref="Path"/>Ŏw肵tH_ɓYtt@C߂Ȃ</para>
		/// <para>ȂꍇÃG[܂B</para>
		/// <para><see cref="nMailException.ErrorCode"/>ɐݒ肳܂B</para>
		/// </remarks>
		public const int ErrorFileOpen = -5;
		/// <summary>
		/// t@CĂ܂B
		/// </summary>
		/// <remarks>
		/// <para><see cref="Flag"/><see cref="PartialAttachmentFile"/> ݒ肵</para>
		/// <para><see cref="GetMail"/>ĂяoۂɁAT[oɕꂽ[ׂ</para>
		/// <para>ĂȂꍇɂ̃G[܂B</para>
		/// <para><see cref="nMailException.ErrorCode"/>ɐݒ肳܂B</para>
		/// </remarks>
		public const int ErrorPartial = -6;
		/// <summary>
		/// Ytt@CƓ̃t@CtH_ɑ݂܂B
		/// </summary>
		/// <remarks>
		/// <para><see cref="nMail.Options.AlreadyFile"/>  <see cref="nMail.Options.FileAlreadyError"/></para>
		/// <para>ݒ肵A<see cref="Path"/>Ŏw肵tH_ɓYtt@CƓÕt@C</para>
		/// <para>ꍇɂ̃G[܂B</para>
		/// <para><see cref="nMailException.ErrorCode"/>ɐݒ肳܂B</para>
		/// </remarks>
		public const int ErrorFileAlready = -7;
		/// <summary>
		/// mۃG[łB
		/// </summary>
		/// <remarks>
		/// ŕR[hϊ邽߂̃mۂł܂łB
		/// </remarks>
		public const int ErrorMemory = -9;
		/// <summary>
		/// ̑̃G[łB
		/// </summary>
		public const int ErrorEtc = -10;
		/// <summary>
		/// Ytt@CMł܂c肪ԂłB
		/// </summary>
		/// <remarks>
		/// <para><see cref="Flag"/><see cref="SuspendAttachmentFile"/>܂</para>
		/// <para><see cref="SuspendNext"/>w肵<see cref="GetMail"/></para>
		/// <para>ĂяoꍇA܂[̎c肪ꍇA<see cref="nMailException.ErrorCode"/></para>
		/// <para>ɐݒ肳܂B</para>
		/// </remarks>
		public const int ErrorSuspendAttachmentFile = -20;
		/// <summary>
		/// Ytt@C݂͑܂B
		/// </summary>
		/// <remarks>
		/// <para><see cref="GetAttachmentFileStatus"/> sAYtt@C݂Ȃꍇ</para>
		/// <para><see cref="PartNo"/> ɐݒ肳܂B</para>
		/// </remarks>
		public const int NoAttachmentFile = -1;
		/// <summary>
		/// Ytt@C݂͑܂AĂ܂B
		/// </summary>
		/// <remarks>
		/// <para><see cref="GetAttachmentFileStatus"/> sAYtt@C݂Ȃꍇ</para>
		/// <para><see cref="PartNo"/> ɐݒ肳܂B</para>
		/// </remarks>
		public const int AttachmentFile = 0;
		/// <summary>
		/// s
		/// </summary>
		/// <para>e탁\bhԂꍇA<see cref="nMailException.ErrorCode"/>ɐݒ肳lłB</para>
		public const int Success = 0;
		/// <summary>
		/// ꂽYtt@C擾܂B
		/// </summary>
		/// <remarks>
		/// <para><see cref="GetMail"/>̑OɁA<see cref="Flag"/>ɐݒ肵Ă܂B</para>
		/// </remarks>
		public const int PartialAttachmentFile = 1;
		/// <summary>
		/// [{̂ݎ擾܂B
		/// </summary>
		/// <remarks>
		/// <para><see cref="GetMail"/>̑OɁA<see cref="Flag"/>ɐݒ肵Ă܂B</para>
		/// </remarks>
		public const int TextOnly = 2;
		/// <summary>
		/// Ytt@CMňꎞx~̈ڂɎw肵܂B
		/// </summary>
		/// <remarks>
		/// <para><see cref="GetMail"/>̑OɁA<see cref="Flag"/>ɐݒ肵Ă܂B</para>
		/// </remarks>
		public const int SuspendAttachmentFile = 4;
		/// <summary>
		/// Ytt@CMňꎞx~̓ڈȍ~Ɏw肵܂B
		/// </summary>
		/// <remarks>
		/// <para><see cref="GetMail"/>̑OɁA<see cref="Flag"/>ɐݒ肵Ă܂B</para>
		/// </remarks>
		public const int SuspendNext = 8;
		/// <summary>
		/// UIDL ׂĎ擾܂B
		/// </summary>
		/// <remarks>
		/// <see cref="GetUidl"/>Ŏw肷邱ƂɂđSĂ UIDL 擾ł܂B
		/// </remarks>
		public const int UidlAll = 0;

		/// <summary>
		/// POP3 |[gԍłB
		/// </summary>
		protected int _port = 110;
		/// <summary>
		/// \PbgnhłB
		/// </summary>
		protected int _socket = ErrorSocket;
		/// <summary>
		/// [łB
		/// </summary>
		protected int _count = -1;
		/// <summary>
		/// [TCYłB
		/// </summary>
		protected int _size = -1;
		/// <summary>
		/// wb_[TCYłB
		/// </summary>
		protected int _header_size = -1;
		/// <summary>
		/// {̃TCYłB
		/// </summary>
		protected int _body_size = -1;
		/// <summary>
		/// [M̐ݒptOłB
		/// </summary>
		protected int _flag = 0;
		/// <summary>
		/// t@CԍłB
		/// </summary>
		protected int _part_no = -1;
		/// <summary>
		/// G[ԍłB
		/// </summary>
		protected int _err = 0;
		/// <summary>
		/// APOP gp邩ǂ̃tOłB
		/// </summary>
		protected bool _apop = false;
		/// <summary>
		/// POP3 T[ołB
		/// </summary>
		protected string _host = "";
		/// <summary>
		/// POP3 [U[łB
		/// </summary>
		protected string _id = "";
		/// <summary>
		/// POP3 pX[hłB
		/// </summary>
		protected string _password = "";
		/// <summary>
		/// Ytt@Cۑp̃pXłB
		/// </summary>
		protected string _path = null;
		/// <summary>
		/// wb_tB[hłB
		/// </summary>
		protected string _field_name = "";
		/// <summary>
		/// {i[obt@łB
		/// </summary>
		protected StringBuilder _body = null;
		/// <summary>
		/// i[obt@łB
		/// </summary>
		protected StringBuilder _subject = null;
		/// <summary>
		/// tۑobt@łB
		/// </summary>
		protected StringBuilder _date = null;
		/// <summary>
		/// oli[obt@łB
		/// </summary>
		protected StringBuilder _from = null;
		/// <summary>
		/// wb_i[obt@łB
		/// </summary>
		protected StringBuilder _header = null;
		/// <summary>
		/// Ytt@Ci[obt@łB
		/// </summary>
		protected StringBuilder _filename = null;
		/// <summary>
		/// Ytt@C̃XgłB
		/// </summary>
		protected string[] _filename_list = null;
		/// <summary>
		/// wb_tB[hei[obt@łB
		/// </summary>
		protected StringBuilder _field = null;
		/// <summary>
		/// t@C ID łB
		/// </summary>
		protected StringBuilder _part_id = null;
		/// <summary>
		/// UIDL i[obt@łB
		/// </summary>
		protected StringBuilder _uidl = null;
		/// <summary>
		/// g@\pobt@łB
		/// </summary>
		protected byte[] _temp = null;
		/// <summary>
		/// Dispose sǂ̃tOłB
		/// </summary>
		private bool _disposed = false;

		/// <summary>
		/// <c>Pop3</c>NX̐VKCX^X܂B
		/// </summary>
		public Pop3()
		{
			Init();
		}
		/// <summary>
		/// <c>Pop3</c>NX̐VKCX^X܂B
		/// <param name="host_name">POP3 T[o[</param>
		/// </summary>
		public Pop3(string host_name)
		{
			Init();
			_host = host_name;
		}
		/// <summary>
		/// 
		/// </summary>
		~Pop3()
		{
			Dispose(false);
		}
		/// <summary>
		/// <see cref="Pop3"/>ɂĎgpĂ邷ׂẴ\[X܂B
		/// </summary>
		public void Dispose()
		{
			Dispose(true);
			GC.SuppressFinalize(this);
		}
		/// <summary>
		/// <see cref="Pop3"/>ɂĎgpĂ邷ׂẴ\[X܂B
		/// </summary>
		/// <param name="disposing">
		/// }l[W\[XƃA}l[W\[X̗ꍇ<c>true</c>B
		/// A}l[W\[Xꍇ<c>false</c>B
		/// </param>
		protected virtual void Dispose(bool disposing)
		{
			if(!_disposed) {
				if(disposing)
				{
				}
				if(_socket != ErrorSocket) {
					Pop3Close(_socket);
					_socket = ErrorSocket;
				}
				_disposed = true;
			}
		}
		/// <summary>
		/// łB
		/// </summary>
		protected void Init()
		{
			_temp = new byte[AttachmentTempSize];
		}

		[DllImport("nMail.DLL", EntryPoint="NMailPop3ConnectPortNo", CharSet=CharSet.Auto)]
		protected static extern int Pop3ConnectPortNo(string Host, int Port);

		[DllImport("nMail.DLL", EntryPoint="NMailPop3Close")]
		protected static extern int Pop3Close(int Socket);

		[DllImport("nMail.DLL", EntryPoint="NMailPop3Authenticate", CharSet=CharSet.Auto)]
		protected static extern int Pop3Authenticate(int Socket, string Id, string Pass, bool APopFlag);

		[DllImport("nMail.DLL", EntryPoint="NMailPop3GetMailStatus", CharSet=CharSet.Auto)]
		protected static extern int Pop3GetMailStatus(int Socket, int No, StringBuilder Subject, StringBuilder Date, StringBuilder From, StringBuilder Header, bool SizeFlag);

		[DllImport("nMail.DLL", EntryPoint="NMailPop3GetMailSize")]
		protected static extern int Pop3GetMailSize(int Socket, int No);

		[DllImport("nMail.DLL", EntryPoint="NMailPop3GetMail", CharSet=CharSet.Auto)]
		protected static extern int Pop3GetMail(int Socket, int No, StringBuilder Subject, StringBuilder Date, StringBuilder From, StringBuilder Header, StringBuilder Body, string Path, StringBuilder FileName);

		[DllImport("nMail.DLL", EntryPoint="NMailPop3GetMailEx", CharSet=CharSet.Auto)]
		protected static extern int Pop3GetMailEx(int Socket, int No, StringBuilder Subject, StringBuilder Date, StringBuilder From, StringBuilder Header, StringBuilder Body, string Path, StringBuilder FileName, byte[] Temp, int Flag);

		[DllImport("nMail.DLL", EntryPoint="NMailPop3DeleteMail")]
		protected static extern int Pop3DeleteMail(int Socket, int No);

		[DllImport("nMail.DLL", EntryPoint="NMailGetHeaderField", CharSet=CharSet.Auto)]
		protected static extern int Pop3GetHeaderField(StringBuilder Field, string Header, string Name, int Size);

		[DllImport("nMail.DLL", EntryPoint="NMailPop3GetUidl", CharSet=CharSet.Auto)]
		protected static extern int Pop3GetUidl(int Socket, int No, StringBuilder Id, int Max);

		[DllImport("nMail.DLL", EntryPoint="NMailPop3GetAttachmentFileStatus", CharSet=CharSet.Auto)]
		protected static extern int Pop3GetAttachmentFileStatus(int Socket, int No, StringBuilder Id, int Max);

		/// <summary>
		/// wb_i[pobt@̃TCY肵܂B
		/// </summary>
		protected void SetHeaderSize()
		{
			if(_header_size < 0)
			{
				_header_size = Options.HeaderMax;
			}
			if(_header_size <= 0)
			{
				_header_size = HeaderSize;
				Options.HeaderMax = _header_size;
			}
		}
		/// <summary>
		/// POP3 T[oɐڑ܂B
		/// </summary>
		/// <remarks>
		/// POP3 T[oɐڑ܂B
		/// </remarks>
		///	<exception cref="ArgumentOutOfRangeException">
		///	|[gԍ܂B
		/// </exception>
		///	<exception cref="nMailException">
		///	POP T[o[Ƃ̐ڑɎs܂B
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void Connect()
		{
			if(_port < 0 || _port > 65536) {
				throw new ArgumentOutOfRangeException();
			}
			_socket = Pop3ConnectPortNo(_host, _port);
			if(_socket == ErrorSocket || _socket == ErrorTimeout)
			{
				_err = _socket;
				_socket = ErrorSocket;
				throw new nMailException("Connect", _err);
			}
		}
		/// <summary>
		/// POP3 T[oɐڑ܂B
		/// </summary>
		/// <param name="host_name">POP3 T[o[</param>
		/// <remarks>
		/// POP3 T[oɐڑ܂B
		/// </remarks>
		///	<exception cref="ArgumentOutOfRangeException">
		///	|[gԍ܂B
		/// </exception>
		///	<exception cref="nMailException">
		///	POP T[oƂ̐ڑɎs܂B
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void Connect(string host_name)
		{
			_host = host_name;
			Connect();
		}
		/// <summary>
		/// POP3 T[oɐڑ܂B
		/// </summary>
		/// <param name="host_name">POP3 T[o</param>
		/// <param name="port_no">|[gԍ</param>
		/// <remarks>
		/// POP3 T[oɐڑ܂B
		/// </remarks>
		///	<exception cref="ArgumentOutOfRangeException">
		///	|[gԍ܂B
		/// </exception>
		///	<exception cref="nMailException">
		///	POP T[oƂ̐ڑɎs܂B
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void Connect(string host_name, int port_no)
		{
			_host = host_name;
			_port = port_no;
			Connect();
		}
		/// <summary>
		/// POP3 T[oɐڑ܂B
		/// </summary>
		/// <param name="port_no">|[gԍ</param>
		/// <remarks>
		/// POP3 T[oɐڑ܂B
		/// </remarks>
		///	<exception cref="ArgumentOutOfRangeException">
		///	|[gԍ܂B
		/// </exception>
		///	<exception cref="nMailException">
		///	POP T[oƂ̐ڑɎs܂B
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void Connect(int port_no)
		{
			_port = port_no;
			Connect();
		}
		/// <summary>
		/// POP3 T[oƂ̐ڑI܂B
		/// </summary>
		public void Close()
		{
			if(_socket != ErrorSocket) {
				Pop3Close(_socket);
			}
			_socket = ErrorSocket;
		}
		/// <summary>
		/// POP3 T[oF؂s܂B
		/// </summary>
		/// <remarks>
		/// POP3 T[oF؂s܂B
		/// </remarks>
		/// <param name="id_str">POP3 [U[ ID</param>
		/// <param name="pass_str">POP3 pX[h</param>
		/// <exception cref="InvalidOperationException">
		///	ڑԂł͂܂B(<see cref="Connect"/>ĂȂAĂяoĂ܂B
		///	</exception>
		///	<exception cref="FormatException">
		///	ID ̓pX[hɕ񂪓Ă܂B
		/// </exception>
		///	<exception cref="nMailException">
		///	T[oƂ̌MɃG[܂B
		/// <see cref="nMailException.Message"/>ɃG[bZ[WA
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void Authenticate(string id_str, string pass_str)
		{
			if(id_str == "" || pass_str == "") {
				throw new FormatException();
			}
			if(_socket == ErrorSocket) {
				throw new InvalidOperationException();
			}
			_id = id_str;
			_password = pass_str;
			_body_size = -1;
			_count = Pop3Authenticate(_socket, _id, _password, _apop);
			if(_count < 0)
			{
				_err = _count;
				throw new nMailException("Authenticate:" + Options.ErrorMessage, _err);
			}
		}
		/// <summary>
		/// POP3 T[oF؂s܂B
		/// </summary>
		/// <remarks>
		/// POP3 T[oF؂s܂B
		/// </remarks>
		/// <param name="id_str">POP3 [U[ ID</param>
		/// <param name="pass_str">POP3 pX[h</param>
		/// <param name="apop_flag">APOP gp邩</param>
		/// <exception cref="InvalidOperationException">
		///	ڑԂł͂܂B(<see cref="Connect"/>ĂȂAĂяoĂ܂B
		///	</exception>
		///	<exception cref="FormatException">
		///	ID ̓pX[hɕ񂪓Ă܂B
		/// </exception>
		///	<exception cref="nMailException">
		///	T[oƂ̌MɃG[܂B
		/// <see cref="nMailException.Message"/>ɃG[bZ[WA
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void Authenticate(string id_str, string pass_str, bool apop_flag)
		{
			_apop = apop_flag;
			Authenticate(id_str, pass_str);
		}

		/// <summary>
		/// [̃Xe[^X擾܂B
		/// </summary>
		/// <param name="no">[ԍ</param>
		/// <remarks>
		/// <paramref name="no"/>p[^ŃXe[^X擾[ԍw肵܂B
		/// <para><see cref="Subject"/>Ŏ擾ł܂B</para>
		/// <para>t<see cref="DateString"/>Ŏ擾ł܂B</para>
		/// <para>ol<see cref="From"/>Ŏ擾ł܂B</para>
		/// <para>wb_<see cref="Header"/>Ŏ擾ł܂B</para>
		/// <para>[TCY<see cref="Size"/>Ŏ擾ł܂B</para>
		/// <para>Xe[^X擾s̏ꍇ̃G[ԍ<see cref="nMailException.ErrorCode"/>Ŏ擾ł܂B</para>
		/// </remarks>
		/// <exception cref="InvalidOperationException">
		///	ڑԂł͂܂B(<see cref="Connect"/>ĂȂAĂяoĂ܂B
		///	</exception>
		///	<exception cref="ArgumentOutOfRangeException">
		///	[ԍ܂B
		/// </exception>
		///	<exception cref="nMailException">
		///	T[oƂ̌MɃG[܂B
		/// <see cref="nMailException.Message"/>ɃG[bZ[WA
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void GetStatus(int no)
		{
			if(_socket == ErrorSocket) {
				throw new InvalidOperationException();
			}
			if(no <= 0) {
				throw new ArgumentOutOfRangeException();
			}
			SetHeaderSize();
			_subject = new StringBuilder(_header_size);
			_date = new StringBuilder(_header_size);
			_from = new StringBuilder(_header_size);
			_header = new StringBuilder(_header_size);
			_err = Pop3GetMailStatus(_socket, no, _subject, _date, _from, _header, false);
			if(_err < 0)
			{
				throw new nMailException("GetStatus:" + Options.ErrorMessage, _err);
			}
		}
		/// <summary>
		/// [̃TCY擾܂B
		/// </summary>
		/// <param name="no">[ԍ</param>
		/// <remarks>
		/// <paramref name="no"/>p[^Ń[TCY擾[ԍw肵܂B
		/// <example>
		/// <para>
		/// [ԍ(ϐ:no)̃[TCY擾B
		/// <code lang="cs">
		///	using(nMail.Pop3 pop = new nMail.Pop3("mail.example.com")) {
		///		try {
		///			pop.Connect();
		/// 		pop.Authenticate("pop3_id", "password");
		///			pop.GetSize(no);
		///			MessageBox.Show(String.Format("[ԍ:{0:d},TCY:{1:d}", no, pop.Size));
		///		}
		///		catch(nMail.nMailException nex)
		///		{
		///			MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message));
		///		}
		///		catch(Exception ex)
		///		{
		///			MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message));
		///		}
		///	}
		/// </code>
		/// <code lang="vbnet">
		///	' VB.NET 2005 ȍ~̏ꍇAC# Ɠl using gpł܂B
		/// Dim pop As nMail.Pop3 = New nMail.Pop3("mail.example.com")
		/// Try
		/// 	pop.Connect()
		/// 	pop.Authenticate("pop3_id", "password")
		///		pop.GetMail(no)
		///		MessageBox.Show(String.Format("[ԍ:{0:d},TCY:{1:d}", no, pop.Size))
		///	Catch nex As nMail.nMailException
		///		MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message))
		///	Catch ex As Exception
		///		MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message))
		///	Finally
		///		pop.Dispose()
		///	End Try
		/// </code>
		/// </para>
		/// </example>
		/// </remarks>
		/// <exception cref="InvalidOperationException">
		///	ڑԂł͂܂B(<see cref="Connect"/>ĂȂAĂяoĂ܂B
		///	</exception>
		///	<exception cref="ArgumentOutOfRangeException">
		///	[ԍ܂B
		/// </exception>
		/// <exception cref="nMailException">
		///	T[oƂ̌MɃG[܂B
		/// <see cref="nMailException.Message"/>ɃG[bZ[WA
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		/// <returns>[TCY</returns>
		public int GetSize(int no)
		{
			if(_socket == ErrorSocket) {
				throw new InvalidOperationException();
			}
			if(no <= 0) {
				throw new ArgumentOutOfRangeException();
			}
			_size = Pop3GetMailSize(_socket, no);
			if(_size < 0) {
				_err = _size;
				throw new nMailException("GetSize:" + Options.ErrorMessage, _err);
			} else {
				_body_size = _size * 2;
			}
			return _size;
		}

		/// <summary>
		/// [擾܂B
		/// </summary>
		/// <param name="no">[ԍ</param>
		/// <remarks>
		/// <paramref name="no"/>p[^Ń[擾[ԍw肵܂B
		/// <para>Ytt@CۑꍇA<see cref="Path"/>ɕۑtH_w肵Ă܂B</para>
		/// <para>g@\gpꍇA<see cref="Flag"/>Őݒ肵Ă܂B</para>
		/// <para><see cref="Subject"/>Ŏ擾ł܂B</para>
		/// <para>t<see cref="DateString"/>Ŏ擾ł܂B</para>
		/// <para>ol<see cref="From"/>Ŏ擾ł܂B</para>
		/// <para>wb_<see cref="Header"/>Ŏ擾ł܂B</para>
		/// <para>[TCY<see cref="Size"/>Ŏ擾ł܂B</para>
		/// <para>Ytt@C<see cref="FileName"/>Ŏ擾ł܂B</para>
		/// </remarks>
		/// <exception cref="InvalidOperationException">
		///	ڑԂł͂܂B<see cref="Connect"/>ĂȂAĂяoĂ܂B
		///	</exception>
		/// <exception cref="DirectoryNotFoundException">
		///	<see cref="Path"/>Ŏw肵tH_݂܂B
		/// </exception>
		///	<exception cref="ArgumentOutOfRangeException">
		///	[ԍ܂B
		/// </exception>
		/// <exception cref="nMailException">
		///	T[oƂ̌MɃG[܂B
		/// <see cref="nMailException.Message"/>ɃG[bZ[WA
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void GetMail(int no)
		{
			if(_socket == ErrorSocket) {
				throw new InvalidOperationException();
			}
			if(_path != null && _path != "") {
				if(!Directory.Exists(_path)) {
					throw new DirectoryNotFoundException(_path);
				}
			}
			if(no <= 0) {
				throw new ArgumentOutOfRangeException();
			}
			if((_flag & SuspendNext) != 0) {
				_err = Pop3GetMailEx(_socket, no, _subject, _date, _from, _header, _body, _path, _filename, _temp, _flag);
			} else {
				SetHeaderSize();
				_subject = new StringBuilder(_header_size);
				_date = new StringBuilder(_header_size);
				_from = new StringBuilder(_header_size);
				_header = new StringBuilder(_header_size);
				_filename = new StringBuilder(MaxPath);
				if(_body_size < 0)
				{
					GetSize(no);
				}
				if(_body_size > 0)
				{
					_body = new StringBuilder(_body_size);
					if(_flag != 0) {
						_err = Pop3GetMailEx(_socket, no, _subject, _date, _from, _header, _body, _path, _filename, _temp, _flag);
					}
					else
					{
						_err = Pop3GetMail(_socket, no, _subject, _date, _from, _header, _body, _path, _filename);
					}
				}
			}
			if(_err != ErrorSuspendAttachmentFile)
			{
				_body_size = -1;
				if(_filename.Length > 0) 
				{
					_filename_list = _filename.ToString().Split(Options.SplitChar);
				} 
				else 
				{
					_filename_list = null;
				}
			}
			if(_err < 0 && _err != ErrorSuspendAttachmentFile) {
				throw new nMailException("GetMail:" + Options.ErrorMessage, _err);
			} 
		}
		/// <summary>
		/// [폜܂B
		/// </summary>
		/// <param name="no">[ԍ</param>
		/// <remarks>
		/// <para>[폜s̏ꍇ̃G[ԍ<see cref="nMailException.ErrorCode"/>Ŏ擾ł܂B</para>
		/// <example>
		/// <para>
		/// w̃[ԍ(ϐ:no)̃TCY擾B
		/// <code lang="cs">
		///	using(nMail.Pop3 pop = new nMail.Pop3("mail.example.com")) {
		///		try {
		///			pop.Connect();
		/// 		pop.Authenticate("pop3_id", "password");
		///			pop.Delete(no);
		///			MessageBox.Show(String.Format("[ԍ:{0:d}폜", no));
		///		}
		///		catch(nMail.nMailException nex)
		///		{
		///			MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message));
		///		}
		///		catch(Exception ex)
		///		{
		///			MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message));
		///		}
		///	}
		/// </code>
		/// <code lang="vbnet">
		///	' VB.NET 2005 ȍ~̏ꍇAC# Ɠl using gpł܂B
		/// Dim pop As nMail.Pop3 = New nMail.Pop3("mail.example.com")
		/// Try
		/// 	pop.Connect()
		/// 	pop.Authenticate("pop3_id", "password")
		///		pop.Delete(no)
		///		MessageBox.Show(String.Format("[ԍ:{0:d}폜", no))
		///	Catch nex As nMail.nMailException
		///		MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message))
		///	Catch ex As Exception
		///		MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message))
		///	Finally
		///		pop.Dispose()
		///	End Try
		/// </code>
		/// </para>
		/// </example>
		/// </remarks>
		/// <exception cref="InvalidOperationException">
		///	ڑԂł͂܂B(<see cref="Connect"/>ĂȂAĂяoĂ܂B
		///	</exception>
		///	<exception cref="ArgumentOutOfRangeException">
		///	[ԍ܂B
		/// </exception>
		/// <exception cref="nMailException">
		///	T[oƂ̌MɃG[܂B
		/// <see cref="nMailException.Message"/>ɃG[bZ[WA
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void Delete(int no)
		{
			if(_socket == ErrorSocket) {
				throw new InvalidOperationException();
			}
			if(no <= 0) {
				throw new ArgumentOutOfRangeException();
			}
			_err = Pop3DeleteMail(_socket, no);
			if(_err < 0)
			{
				throw new nMailException("Delete:" + Options.ErrorMessage, _err);
			}
		}
		/// <summary>
		/// Ytt@C̑݃`FbNs܂B
		/// </summary>
		/// <param name="no">[ԍ</param>
		/// <remarks>
		/// <para>Ytt@C̕<see cref="PartNo"/>Ŏ擾ł܂B</para>
		/// <para><see cref="NoAttachmentFile"/>̏ꍇYtt@C͂܂B</para>
		/// <para><see cref="AttachmentFile"/>̏ꍇĂȂYtt@Ct[łB</para>
		/// <para>1 ȏ̏ꍇĂYtt@CŕԂl̓p[gԍ\܂B</para>
		/// <para>1 ̏ꍇ́A<see cref="Flag"/><see cref="PartialAttachmentFile"/> ݒ肵
		/// <see cref="GetMail"/>ĂяoƓYtt@Cĕۑ\łB</para>
		/// </remarks>
		/// <exception cref="InvalidOperationException">
		///	ڑԂł͂܂B(<see cref="Connect"/>ĂȂAĂяoĂ܂B
		///	</exception>
		///	<exception cref="ArgumentOutOfRangeException">
		///	[ԍ܂B
		/// </exception>
		/// <returns>true œYtt@C</returns>
		public bool GetAttachmentFileStatus(int no)
		{
			if(_socket == ErrorSocket) {
				throw new InvalidOperationException();
			}
			if(no <= 0) {
				throw new ArgumentOutOfRangeException();
			}
			SetHeaderSize();
			_part_id = new StringBuilder(_header_size);
			_part_no = Pop3GetAttachmentFileStatus(_socket, no, _part_id, _header_size);
			if(_part_no > 0)
			{
				return true;
			}
			else
			{
				return false;
			}
		}

		/// <summary>
		/// [ UIDL 擾܂B
		/// </summary>
		/// <param name="no">[ԍ</param>
		/// <remarks>
		/// <para>擾 UIDL <see cref="Uidl"/>Ŏ擾ł܂B</para>
		/// <para><paramref name="no"/><see cref="UidlAll"/>w肷ƁA
		/// POP3 T[oɂ邷ׂẴ[ UIDL 擾܂B</para>
		/// <example>
		/// <para>
		/// w̃[ԍ(ϐ:no) UIDL 擾B
		///	<code lang="cs">
		///	using(nMail.Pop3 pop = new nMail.Pop3("mail.example.com")) {
		///		try {
		///			pop.Connect();
		/// 		pop.Authenticate("pop3_id", "password");
		///			pop.GetUidl(no);
		///			MessageBox.Show("Uidl=" + pop.Uidl);
		/// 	}
		///		catch(nMail.nMailException nex)
		///		{
		///			MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message));
		///		}
		///		catch(Exception ex)
		///		{
		///			MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message));
		///		}
		///	}
		/// </code>
		/// <code lang="vbnet">
		///	' VB.NET 2005 ȍ~̏ꍇAC# Ɠl using gpł܂B
		/// Dim pop As nMail.Pop3 = New nMail.Pop3("mail.example.com")
		/// Try
		/// 	pop.Connect()
		/// 	pop.Authenticate("pop3_id", "password")
		///		pop.GetUidl(no)
		///		MessageBox.Show("Uidl=" + pop.Uidl)
		///	Catch nex As nMail.nMailException
		///		MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message))
		///	Catch ex As Exception
		///		MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message))
		///	Finally
		///		pop.Dispose()
		///	End Try
		/// </code>
		/// </para>
		/// </example>
		/// </remarks>
		/// <exception cref="InvalidOperationException">
		///	ڑԂł͂܂B(<see cref="Connect"/>ĂȂAĂяoĂ܂B
		///	</exception>
		/// <exception cref="nMailException">
		///	T[oƂ̌MɃG[܂B
		/// <see cref="nMailException.Message"/>ɃG[bZ[WA
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void GetUidl(int no)
		{
			if(_socket == ErrorSocket) {
				throw new InvalidOperationException();
			}
			SetHeaderSize();
			_uidl = new StringBuilder(_header_size);
			_err = Pop3GetUidl(_socket, no, _uidl, _header_size);
			if(_err < 0)
			{
				throw new nMailException("GetUild:" + Options.ErrorMessage, _err);
			}
		}
		/// <summary>
		/// [wb_w̃tB[h̓e擾܂B
		/// </summary>
		/// <param name="field_name">tB[h</param>
		/// <remarks>
		/// POP3 T[oƂ̐ڑƂ͖֌WɎgpł܂B
		/// <para>wb_́A<see cref="Header"/>Őݒ肵Ă܂B
		/// <see cref="GetMail"/>ŎMɌĂяoꍇA
		/// M[̃wb_gp܂B</para>
		/// <para>擾tB[he<see cref="Field"/>Ŏ擾ł܂B</para>
		/// <example>
		/// <para>
		/// w̃[ԍ(ϐ:no) X-Mailer wb_tB[h擾B
		///	<code lang="cs">
		///	using(nMail.Pop3 pop = new nMail.Pop3("mail.example.com")) {
		///		try {
		///			pop.Connect();
		/// 		pop.Authenticate("pop3_id", "password");
		///			pop.GetMail(no);
		///			pop.GetHeaderField("X-Mailer");
		///			MessageBox.Show("X-Mailer:" + pop.Field);
		///		}
		///		catch(nMail.nMailException nex)
		///		{
		///			MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message));
		///		}
		///		catch(Exception e)
		///		{
		///			MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message));
		///		}
		///	}
		/// </code>
		/// <code lang="vbnet">
		///	' VB.NET 2005 ȍ~̏ꍇAC# Ɠl using gpł܂B
		/// Dim pop As nMail.Pop3 = New nMail.Pop3("mail.example.com")
		///	Try
		/// 	pop.Connect()
		/// 	pop.Authenticate("pop3_id", "password")
		///		pop.GetMail(no)
		///		pop.GetHeaderField("X-Mailer:")
		///		MessageBox.Show("X-Mailer:" + pop.Field)
		///	Catch nex As nMail.nMailException
		///		MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message))
		///	Catch ex As Exception
		///		MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message))
		///	Finally
		///		pop.Dispose()
		///	End Try
		/// </code>
		/// </para>
		/// </example>
		/// </remarks>
		/// <exception cref="nMailException">
		///	T[oƂ̌MɃG[܂B
		/// <see cref="nMailException.Message"/>ɃG[bZ[WA
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void GetHeaderField(string field_name)
		{
			_field_name = field_name;
			SetHeaderSize();
			_field = new StringBuilder(_header_size);
			_err = Pop3GetHeaderField(_field, _header.ToString(), _field_name, _header_size);
			if(_err < 0)
			{
				throw new nMailException("GetHeaderField", _err);
			}
		}
		/// <summary>
		/// POP3 |[gԍłB
		/// </summary>
		/// <value>POP3 |[gԍ</value>
		public int Port {
			get
			{
				return _port;
			}
			set
			{
				_port = value;
			}
		}
		/// <summary>
		/// \PbgnhłB
		/// </summary>
		/// <value>\Pbgnh</value>
		public int Handle {
			get
			{
				return _socket;
			}
		}
		/// <summary>
		/// POP3 T[õ[łB
		/// </summary>
		/// <value>POP3 T[õ[</value>
		public int Count {
			get
			{
				return _count;
			}
		}
		/// <summary>
		/// [̃TCYTCYłB
		/// </summary>
		/// <value>[̃TCY</value>
		public int Size {
			get
			{
				return _size;
			}
		}
		/// <summary>
		/// POP3 T[ołB
		/// </summary>
		/// <value>POP3 T[o</value>
		public string HostName
		{
			get
			{
				return _host;
			}
			set
			{
				_host = value;
			}
		}
		/// <summary>
		/// POP3 [U[łB
		/// </summary>
		/// <value>POP3 [U[</value>
		public string Id
		{
			get
			{
				return _id;
			}
			set
			{
				_id = value;
			}
		}
		/// <summary>
		/// POP3 pX[hłB
		/// </summary>
		/// <value>POP3 pX[h</value>
		public string Password
		{
			get
			{
				return _password;
			}
			set
			{
				_password = value;
			}
		}
		/// <summary>
		/// Ytt@CۑtH_łB
		/// </summary>
		/// <remarks>
		/// ""  null ̏ꍇۑ܂B
		/// </remarks>
		/// <value>Ytt@CۑtH_</value>
		public string Path
		{
			get
			{
				return _path;
			}
			set
			{
				_path = value;
			}
		}
		/// <summary>
		/// [̖{łB
		/// </summary>
		/// <value>[{</value>
		public string Body
		{
			get
			{
				if(_body == null)
				{
					return "";
				}
				else
				{
					return _body.ToString();
				}
			}
		}
		/// <summary>
		/// [̌łB
		/// </summary>
		/// <value>[̌</value>
		public string Subject
		{
			get
			{
				if(_subject == null)
				{
					return "";
				}
				else
				{
					return _subject.ToString();
				}
			}
		}
		/// <summary>
		/// [̑M̕łB
		/// </summary>
		/// <value>[M</value>
		public string DateString
		{
			get
			{
				if(_date == null)
				{
					return "";
				}
				else
				{
					return _date.ToString();
				}
			}
		}
		/// <summary>
		/// [̍olłB
		/// </summary>
		/// <value>[̍ol</value>
		public string From
		{
			get
			{
				if(_from == null)
				{
					return "";
				}
				else
				{
					return _from.ToString();
				}
			}
		}
		/// <summary>
		/// [̃wb_łB
		/// </summary>
		/// <value>[̃wb_</value>
		public string Header
		{
			get
			{
				if(_header == null)
				{
					return "";
				}
				else
				{
					return _header.ToString();
				}
			}
			set
			{
				_header = new StringBuilder(value);
			}
		}
		/// <summary>
		/// Ytt@CłB
		/// </summary>
		/// <remarks>
		/// ̓Ytt@CꍇA"," ŋ؂Ċi[܂B
		/// <see cref="Options.SplitChar"/>ŋ؂蕶ύXł܂B
		/// </remarks>
		/// <value>Ytt@C</value>
		public string FileName
		{
			get
			{
				if(_filename == null)
				{
					return "";
				}
				else
				{
					return _filename.ToString();
				}
			}
		}
		/// <summary>
		/// Ytt@C̔złB
		/// </summary>
		/// <value>Ytt@C</value>
		public string[] FileNameList
		{
			get
			{
				return _filename_list;
			}
		}
		/// <summary>
		/// wb_̃tB[hłB
		/// </summary>
		/// <value>wb_̃tB[h</value>
		public string FieldName
		{
			get
			{
				if(_field_name == null)
				{
					return "";
				}
				else
				{
					return _field_name;
				}
			}
		}
		/// <summary>
		/// wb_tB[h̓ełB
		/// </summary>
		/// <value>wb_tB[h̓e</value>
		public string Field
		{
			get
			{
				if(_field == null)
				{
					return "";
				}
				else
				{
					return _field.ToString();
				}
			}
		}
		/// <summary>
		/// Ytt@C̕łB
		/// </summary>
		/// <value>Ytt@C̕</value>
		public int PartNo
		{
			get
			{
				return _part_no;
			}
		}
		/// <summary>
		/// Ytt@C ID łB
		/// </summary>
		/// <value>Ytt@C ID</value>
		public string PartId
		{
			get
			{
				if(_part_id == null)
				{
					return "";
				}
				else
				{
					return _part_id.ToString();
				}
			}
		}
		/// <summary>
		/// [ UIDL łB
		/// </summary>
		/// <value>[ UIDL</value>
		public string Uidl
		{
			get
			{
				if(_uidl == null)
				{
					return "";
				}
				else
				{
					return _uidl.ToString();
				}
			}
		}
		/// <summary>
		/// APOP gp邩ǂ̃tOłB
		/// </summary>
		/// <remarks>
		/// true  APOP gp܂B
		/// </remarks>
		/// <value>APOP gp邩ǂ̃tO</value>
		public bool APop
		{
			get
			{
				return _apop;
			}
			set
			{
				_apop = value;
			}
		}
		/// <summary>
		/// [g@\wtOłB
		/// </summary>
		/// <remarks>
		/// <para><see cref="PartialAttachmentFile"/>ꂽYtt@C擾܂B</para>
		/// <para><see cref="TextOnly"/>[{̂ݎ擾܂B</para>
		/// <para><see cref="SuspendAttachmentFile"/>Ytt@CMňꎞx~̈ڂɎw肵܂B</para>
		/// <para><see cref="SuspendNext"/>Ytt@CMňꎞx~̓ڈȍ~Ɏw肵܂B</para>
		/// </remarks>
		public int Flag
		{
			get
			{
				return _flag;
			}
			set
			{
				_flag = value;
			}
		}
		/// <summary>
		/// G[ԍłB
		/// </summary>
		/// <value>G[ԍ</value>
		public int ErrorCode
		{
			get
			{
				return _err;
			}
		}
	}
	/// <summary>
	/// SMTP [MNX
	/// </summary>
	/// <example>
	/// <para>
	/// [𑗐MB
	///	<code lang="cs">
	///	using(nMail.Smtp smtp = new nMail.Smtp("mail.example.com")) {
	///		try {
	///			smtp.SendMail("to@example.net", "from@example.com", "eXg", "{s\r\ns");
	///		}
	///		catch(nMail.nMailException nex)
	///		{
	///			MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message));
	///		}
	///		catch(Exception ex)
	///		{
	///			MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message));
	///		}
	///	}
	/// </code>
	/// <code lang="vbnet">
	///	' VB.NET 2005 ȍ~̏ꍇAC# Ɠl using gpł܂B
	/// Dim smtp As nMail.Smtp = New nMail.Smtp("mail.example.com")
	///	Try
	/// 	smtp.SendMail("to@example.net", "from@example.com", "eXg", "{s" + ControlChars.CrLf + "s")
	///	Catch nex As nMail.nMailException
	///		MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message))
	///	Catch ex As Exception
	///		MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message))
	///	Finally
	///		smtp.Dispose()
	///	End Try
	/// </code>
	/// </para>
	/// <para>
	/// SMTP AUTH gpă[𑗐MB
	///	<code lang="cs">
	///	using(nMail.Smtp smtp = new nMail.Smtp("mail.example.com")) {
	///		try {
	///			smtp.Connect();
	///			smpt.Authenticate("smtp_id", "password", nMail.Smtp.AuthPlain | nMail.Smtp.AuthLogin | nMail.Smtp.AuthCramMd5);
	///			smtp.SendMail("to@example.net", "from@example.com", "eXg", "{s\r\ns");
	///		}
	///		catch(nMail.nMailException nex)
	///		{
	///			MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message));
	///		}
	///		catch(Exception ex)
	///		{
	///			MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message));
	///		}
	///	}
	/// </code>
	/// <code lang="vbnet">
	///	' VB.NET 2005 ȍ~̏ꍇAC# Ɠl using gpł܂B
	/// Dim smtp As nMail.Smtp = New nMail.Smtp("mail.example.com")
	///	Try
	/// 	smtp.Connect()
	/// 	smtp.Authenticate("smtp_id", "password", nMail.Smtp.AuthPlain Or nMail.Smtp.AuthLogin Or nMail.Smtp.AuthCramMd5)
	/// 	smtp.SendMail("to@example.net", "from@example.com", "eXg", "{s" + ControlChars.CrLf + "s")
	///	Catch nex As nMail.nMailException
	///		MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message))
	///	Catch ex As Exception
	///		MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message))
	///	Finally
	///		smtp.Dispose()
	///	End Try
	/// </code>
	/// </para>
	/// <para>
	/// ꎞx~@\gă[𑗐MB
	///	<code lang="cs">
	///	using(nMail.Smtp smtp = new nMail.Smtp("mail.example.com")) {
	///		try {
	///			// Ytt@C̎w
	///			smtp.FileName = @"z:\file.dat";
	///			smtp.Flag = nMail.Smtp.SuspendAttachmentFile;
	///			smtp.Connect();
	///			// ꎞx~@\̂ݎgꍇł Authenticate ̌Ăяo͕KvłB
	///			// Authenticate("", "", AuthNotUse); łB
	///			smtp.Authenticate();
	///			smtp.SendMail("to@example.net", "from@example.com", "eXg", "{s\r\ns");
	///			smtp.Flag = nMail.Smtp.SuspendNext;
	///			while(smtp.ErrorCode == nMail.Smtp.ErrorSuspendAttachmentFile)
	///			{
	///				smtp.SendMail();
	///				// x~̏
	///				Application.DoEvents();
	///			}
	///		}
	///		catch(nMail.nMailException nex)
	///		{
	///			MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message));
	///		}
	///		catch(Exception ex)
	///		{
	///			MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message));
	///		}
	///	}
	/// </code>
	/// <code lang="vbnet">
	///	' VB.NET 2005 ȍ~̏ꍇAC# Ɠl using gpł܂B
	/// Dim smtp As nMail.Smtp = New nMail.Smtp("mail.example.com")
	///	Try
	///		smtp.FileName = "z:\file.dat"
	/// 	smtp.Flag = nMail.Smtp.SuspendAttachmentFile
	///		smtp.Connect()
	/// 	smtp.Authenticate();
	/// 	smtp.SendMail("to@example.net", "from@example.com", "eXg", "{s" + ControlChars.CrLf + "s")
	///		smtp.Flag = nMail.Smtp.SuspendNext
	///		Do While smtp.ErrorCode = nMail.Smtp.ErrorSuspendAttachmentFile
	///			smtp.SendMail()
	///			' x~̏
	///			Application.DoEvents()
	///		Loop
	///	Catch nex As nMail.nMailException
	///		MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message))
	///	Catch ex As Exception
	///		MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message))
	///	Finally
	///		smtp.Dispose()
	///	End Try
	/// </code>
	/// </para>
	/// <para>
	/// SMTP AUTH gpAɈꎞx~@\gă[𑗐MB
	///	<code lang="cs">
	///	using(nMail.Smtp smtp = new nMail.Smtp("mail.example.com")) {
	///		try {
	///			// Ytt@C̎w
	///			smtp.FileName = @"z:\file.dat";
	///			smtp.Flag = nMail.Smtp.SuspendAttachmentFile;
	///			smtp.Connect();
	///			smpt.Authenticate("smtp_id", "password", nMail.Smtp.AuthPlain | nMail.Smtp.AuthLogin | nMail.Smtp.AuthCramMd5);
	///			smtp.SendMail("to@example.net", "from@example.com", "eXg", "{s\r\ns");
	///			smtp.Flag = nMail.Smtp.SuspendNext;
	///			while(smtp.ErrorCode == nMail.Smtp.ErrorSuspendAttachmentFile)
	///			{
	///				smtp.SendMail();
	///				// x~̏
	///				Application.DoEvents();
	///			}
	///		}
	///		catch(nMail.nMailException nex)
	///		{
	///			MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message));
	///		}
	///		catch(Exception ex)
	///		{
	///			MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message));
	///		}
	///	}
	/// </code>
	/// <code lang="vbnet">
	///	' VB.NET 2005 ȍ~̏ꍇAC# Ɠl using gpł܂B
	/// Dim smtp As nMail.Smtp = New nMail.Smtp("mail.example.com")
	///	Try
	///		smtp.FileName = "z:\file.dat"
	/// 	smtp.Flag = nMail.Smtp.SuspendAttachmentFile
	///		smtp.Connect()
	///		smpt.Authenticate("smtp_id", "password", nMail.Smtp.AuthPlain Or nMail.Smtp.AuthLogin Or nMail.Smtp.AuthCramMd5)
	/// 	smtp.SendMail("to@example.net", "from@example.com", "eXg", "{s" + ControlChars.CrLf + "s")
	///		smtp.Flag = nMail.Smtp.SuspendNext
	///		Do While smtp.ErrorCode = nMail.Smtp.ErrorSuspendAttachmentFile
	///			smtp.SendMail()
	///			' x~̏
	///			Application.DoEvents()
	///		Loop
	///	Catch nex As nMail.nMailException
	///		MessageBox.Show(String.Format("G[ ԍ:{0:d} bZ[W:{1:s}", nex.ErrorCode, nex.Message))
	///	Catch ex As Exception
	///		MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message))
	///	Finally
	///		smtp.Dispose()
	///	End Try
	/// </code>
	/// </para>
	/// </example>
	public class Smtp : IDisposable
	{
		/// <summary>
		/// g@\pobt@̃TCYłB
		/// </summary>
		protected const int AttachmentTempSize = 400;

		/// <summary>
		/// \PbgG[͔ڑԂłB
		/// </summary>
		public const int ErrorSocket = -1;
		/// <summary>
		/// F؎sG[łB
		/// </summary>
		public const int ErrorAuthenticate = -2;
		/// <summary>
		/// ^CAEgG[łB
		/// </summary>
		public const int ErrorTimeout = -4;
		/// <summary>
		/// Ytt@CI[vsG[łB
		/// </summary>
		public const int ErrorFileOpen = -5;
		/// <summary>
		/// T[ow肵F،`ɑΉĂ܂B
		/// </summary>
		public const int ErrorAuthenticateNoSupport = -8;
		/// <summary>
		/// mۃG[łB
		/// </summary>
		public const int ErrorMemory = -9;
		/// <summary>
		/// ̑̃G[łB
		/// </summary>
		public const int ErrorEtc = -10;
		/// <summary>
		/// [M̈ꎞx~ԂłB
		/// </summary>
		public const int ErrorSuspendAttachmentFile = -20;
		/// <summary>
		/// T[rXpł܂B
		/// </summary>
		public const int ErrorServiceNotAvaliable = -421;
		/// <summary>
		/// [{bNXgpł܂Bigpj
		/// </summary>
		public const int ErrorMailboxUnavalable = -450;
		/// <summary>
		/// T[oG[łB
		/// </summary>
		public const int ErrorLocal = -451;
		/// <summary>
		/// VXeeʕsG[łB
		/// </summary>
		public const int ErrorInsufficientSystemStorage = -452;
		/// <summary>
		/// R}h̕@G[łB
		/// </summary>
		public const int ErrorSyntax = -500;
		/// <summary>
		/// p[^̕@G[łB
		/// </summary>
		public const int ErrorParameter = -501;
		/// <summary>
		/// R}hłB
		/// </summary>
		public const int ErrorCommandNotImplemented = -502;
		/// <summary>
		/// R}h̃V[PXُłB
		/// </summary>
		public const int ErrorBadSequence =-503;
		/// <summary>
		/// SMTP F؎słB
		/// </summary>
		public const int ErrorSmtpAuthenticate = -535;
		/// <summary>
		/// M悪܂B
		/// </summary>
		public const int ErrorUserUnkown = -550;
		/// <summary>
		/// [U[݂ȂA]悪܂B
		/// </summary>
		public const int ErrorUserNotLocal = -551;
		/// <summary>
		/// eʃI[o[G[łB
		/// </summary>
		public const int ErrorExceededStorageAllocation =-552;
		/// <summary>
		/// [{bNX܂B
		/// </summary>
		public const int ErrorMailboxNameNotAllowed = -553;
		/// <summary>
		/// [h~G[łB
		/// </summary>
		public const int ErrorRelayOperationRejected =-553;
		/// <summary>
		/// gUNVɎs܂B
		/// </summary>
		public const int ErrorTransactionFailed = -554;
		/// <summary>
		/// MtB[h nMail.DLL Ő܂B
		/// </summary>
		public const int AddDateField = 1;
		/// <summary>
		/// Message-ID tB[h nMail.DLL Ő܂B
		/// </summary>
		public const int AddMessageId = 2;
		/// <summary>
		/// 傫ȃTCY̓Ytt@CMɈU߂܂B
		/// </summary>
		public const int SuspendAttachmentFile = 4;
		/// <summary>
		/// 傫ȃTCY̓Ytt@CMڈȍ~łB
		/// </summary>
		public const int SuspendNext = 8;
		/// <summary>
		/// RFC2231 œYtt@CGR[h܂B
		/// </summary>
		public const int FileNameRfc2231 = 16;
		/// <summary>
		/// UTF-8 Ń[GR[h܂iBASE64ŃGR[h܂j
		/// </summary>
		public const int EncodeUtf8 = 32;
		/// <summary>
		/// łB
		/// </summary>
		public const int Success = 0;
		/// <summary>
		/// SMTP AUTH ͎gp܂B
		/// </summary>
		public const int AuthNotUse = 0;
		/// <summary>
		/// SMTP AUTH PLAIN gp܂B
		/// </summary>
		public const int AuthPlain = 1;
		/// <summary>
		/// SMTP AUTH LOGIN gp܂B
		/// </summary>
		public const int AuthLogin = 2;
		/// <summary>
		/// SMTP AUTH CRAM MD5 gp܂B
		/// </summary>
		public const int AuthCramMd5 = 4;

		/// <summary>
		/// SMTP |[gԍłB
		/// </summary>
		protected int _port = 25;
		/// <summary>
		/// \PbgnhłB
		/// </summary>
		protected int _socket = ErrorSocket;
		/// <summary>
		/// [Mg@\̎włB
		/// </summary>
		protected int _flag = 0;
		/// <summary>
		/// G[ԍłB
		/// </summary>
		protected int _err = 0;
		/// <summary>
		/// SMTP AUTH ̃[hłB
		/// </summary>
		protected int _mode = AuthNotUse;
		/// <summary>
		/// SMTP T[ołB
		/// </summary>
		protected string _host = "";
		/// <summary>
		/// SMTP AUTH [U[łB
		/// </summary>
		protected string _id = "";
		/// <summary>
		/// SMTP AUTH pX[hłB
		/// </summary>
		protected string _password = "";
		/// <summary>
		/// [̈łB
		/// </summary>
		protected string _to = "";
		/// <summary>
		/// [ CC łB
		/// </summary>
		protected string _cc = "";
		/// <summary>
		/// [ BCC łB
		/// </summary>
		protected string _bcc = "";
		/// <summary>
		/// [̍olłB
		/// </summary>
		protected string _from = "";
		/// <summary>
		/// [̌łB
		/// </summary>
		protected string _subject = "";
		/// <summary>
		/// [̖{łB
		/// </summary>
		protected string _body = "";
		/// <summary>
		/// [̒ǉwb_łB
		/// </summary>
		protected string _header = "";
		/// <summary>
		/// [ɓYtt@CłB
		/// </summary>
		protected string _filename = "";
		/// <summary>
		/// Ytt@C̃XgłB
		/// </summary>
		protected string[] _filename_list = null;
		/// <summary>
		/// g@\pobt@łB
		/// </summary>
		protected byte[] _temp = null;
		/// <summary>
		/// Connect() gǂ̃tOłB
		/// </summary>
		protected bool _connect_flag = false;
		/// <summary>
		/// Dispose sǂ̃tOłB
		/// </summary>
		private bool _disposed = false;

		[DllImport("nMail.DLL", EntryPoint="NMailSmtpSendMailPortNo", CharSet=CharSet.Auto)]
		protected static extern int SmtpSendMailPortNo(String HostName, String To, String Cc, String Bcc, String From, String Subject, String Body, String Header, String Path, int Flag, int PortNo);

		[DllImport("nMail.DLL", EntryPoint="NMailSmtpConnect", CharSet=CharSet.Auto)]
		protected static extern int SmtpConnect(string Host);

		[DllImport("nMail.DLL", EntryPoint="NMailSmtpConnectPortNo", CharSet=CharSet.Auto)]
		protected static extern int SmtpConnectPortNo(string Host, int PortNo);

		[DllImport("nMail.DLL", EntryPoint="NMailSmtpAuthenticate", CharSet=CharSet.Auto)]
		protected static extern int SmtpAuthenticate(int Socket, string HostName, string Id, string Pass, int Mode);

		[DllImport("nMail.DLL", EntryPoint="NMailSmtpSendMailEx", CharSet=CharSet.Auto)]
		protected static extern int SmtpSendMailEx(int Socket, string To, string Cc, string Bcc, string From, string Subject, String Body, String Header, String Path, byte[] Temp, int Flag);

		[DllImport("nMail.DLL", EntryPoint="NMailSmtpClose")]
		protected static extern int SmtpClose(int Socket);

		/// <summary>
		/// <c>Smtp</c>NX̐VKCX^X܂B
		/// </summary>
		public Smtp()
		{
			Init();
		}
		/// <summary>
		/// <c>Smtp</c>NX̐VKCX^X܂B
		/// </summary>
		/// <param name="host_name">SMTP T[o</param>
		public Smtp(string host_name)
		{
			_host = host_name;
			Init();
		}
		/// <summary>
		/// 
		/// </summary>
		~Smtp()
		{
			Dispose(false);
		}
		/// <summary>
		/// <see cref="Smtp"/>ɂĎgpĂ邷ׂẴ\[X܂B
		/// </summary>
		public void Dispose()
		{
			Dispose(true);
			GC.SuppressFinalize(this);
		}
		/// <summary>
		/// łB
		/// </summary>
		protected void Init()
		{
			_temp = new byte[AttachmentTempSize];
		}
		/// <summary>
		/// <see cref="Smtp"/>ɂĎgpĂ邷ׂẴ\[X܂B
		/// </summary>
		/// <param name="disposing">
		/// }l[W\[XƃA}l[W\[X̗ꍇ<c>true</c>B
		/// A}l[W\[Xꍇ<c>false</c>B
		/// </param>
		protected virtual void Dispose(bool disposing)
		{
			if(!_disposed) {
				if(disposing)
				{
				}
				if(_connect_flag && _socket != ErrorSocket) {
					SmtpClose(_socket);
				}
				_connect_flag = false;
				_socket = ErrorSocket;
				_disposed = true;
			}
		}
		/// <summary>
		/// [𑗐M܂B
		/// </summary>
		/// <remarks>
		///	ꎞx~@\̓ڈȍ~̌ĂяoŎgp܂B
		/// </remarks>
		/// <exception cref="FileNotFoundException">
		/// <see cref="FileName"/>Őݒ肳Ăt@C݂܂B
		/// </exception>
		/// <exception cref="nMailException">
		///	T[oƂ̌MɃG[܂B
		/// <see cref="nMailException.Message"/>ɃG[bZ[WA
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void SendMail()
		{
			_filename = "";
			if(_filename_list != null)
			{
				if(_filename_list.Length > 0)
				{
					for(int no = 0 ; no < _filename_list.Length ; no++)
					{
						if(!File.Exists(_filename_list[no]))
						{
							throw new FileNotFoundException(_filename_list[no]);
						}
					}
					_filename = String.Join(Convert.ToString(Options.SplitChar), _filename_list);
				}
			}
			if(_connect_flag)
			{
				_err = SmtpSendMailEx(_socket, _to, _cc, _bcc, _from, _subject, _body, _header, _filename, _temp, _flag);
			}
			else
			{
				_err = SmtpSendMailPortNo(_host, _to, _cc, _bcc, _from, _subject, _body, _header, _filename, _flag, _port);
			}
			if(_err < 0 && _err != ErrorSuspendAttachmentFile)
			{
				throw new nMailException("SendMail:" + Options.ErrorMessage, _err);
			}
		}
		/// <summary>
		/// [𑗐M܂B
		/// </summary>
		/// <param name="to_str"></param>
		/// <param name="from_str">ol</param>
		/// <param name="subject_str"></param>
		/// <param name="body_str">{</param>
		/// <remarks>
		/// <paramref name="to_str"/>p[^Ń[̈w肵܂B
		/// <paramref name="from_str"/>p[^ōolw肵܂B
		/// <paramref name="subject_str"/>p[^Ōw肵܂B
		/// <paramref name="body_str"/>p[^Ŗ{w肵܂B
		/// <para>CC w肵ꍇA<see cref="Cc"/>Ɏw肵Ă܂B</para>
		/// <para>BCC w肵ꍇA<see cref="Bcc"/>Ɏw肵Ă܂B</para>
		/// <para>t@CYtꍇA<see cref="FileName"/>Ɏw肵Ă܂B</para>
		/// </remarks>
		/// <exception cref="FileNotFoundException">
		/// <see cref="FileName"/>Őݒ肳Ăt@C݂܂B
		/// </exception>
		/// <exception cref="nMailException">
		///	T[oƂ̌MɃG[܂B
		/// <see cref="nMailException.Message"/>ɃG[bZ[WA
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void SendMail(string to_str, string from_str, string subject_str, string body_str)
		{
			_to = to_str;
			_from = from_str;
			_subject = subject_str;
			_body = body_str;
			SendMail();
		}
		/// <summary>
		/// SMTP T[oɐڑ܂B
		/// </summary>
		/// <remarks>
		///	SMTP AUTH шꎞx~@\gꍇɎgp܂B
		/// </remarks>
		///	<exception cref="FormatException">
		///	T[oɕ񂪓Ă܂B
		/// </exception>
		///	<exception cref="ArgumentOutOfRangeException">
		///	|[gԍ܂B
		/// </exception>
		/// <exception cref="nMailException">
		///	T[oƂ̌MɃG[܂B
		/// <see cref="nMailException.Message"/>ɃG[bZ[WA
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void Connect()
		{
			if(_host == "") {
				throw new FormatException();
			}
			if(_port < 0 || _port > 65536) {
				throw new ArgumentOutOfRangeException();
			}
			_socket = SmtpConnectPortNo(_host, _port);
			if(_socket == ErrorSocket || _socket == ErrorTimeout)
			{
				_err = _socket;
				_socket = ErrorSocket;
				throw new nMailException("Connect", _err);
			} else {
				_connect_flag = true;
			}
		}
		/// <summary>
		/// SMTP T[oɐڑ
		/// </summary>
		/// <param name="host_name">SMTP T[o</param>
		/// <remarks>
		///	SMTP AUTH шꎞx~@\gꍇɎgp܂B
		/// </remarks>
		///	<exception cref="FormatException">
		///	T[oɕ񂪓Ă܂B
		/// </exception>
		///	<exception cref="ArgumentOutOfRangeException">
		///	|[gԍ܂B
		/// </exception>
		/// <exception cref="nMailException">
		///	T[oƂ̌MɃG[܂B
		/// <see cref="nMailException.Message"/>ɃG[bZ[WA
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void Connect(string host_name)
		{
			_host = host_name;
			Connect();
		}
		/// <summary>
		/// SMTP T[oɐڑ
		/// </summary>
		/// <param name="host_name">SMTP T[o</param>
		/// <param name="port_no">|[gԍ</param>
		/// <remarks>
		///	SMTP AUTH шꎞx~@\gꍇɎgp܂B
		/// </remarks>
		///	<exception cref="FormatException">
		///	T[oɕ񂪓Ă܂B
		/// </exception>
		///	<exception cref="ArgumentOutOfRangeException">
		///	|[gԍ܂B
		/// </exception>
		/// <exception cref="nMailException">
		///	T[oƂ̌MɃG[܂B
		/// <see cref="nMailException.Message"/>ɃG[bZ[WA
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void Connect(string host_name, int port_no)
		{
			_host = host_name;
			_port = port_no;
			Connect();
		}
		/// <summary>
		/// SMTP T[oɐڑ
		/// </summary>
		/// <param name="port_no">|[gԍ</param>
		/// <remarks>
		///	SMTP AUTH шꎞx~@\gꍇɎgp܂B
		/// </remarks>
		///	<exception cref="FormatException">
		///	T[oɕ񂪓Ă܂B
		/// </exception>
		///	<exception cref="ArgumentOutOfRangeException">
		///	|[gԍ܂B
		/// </exception>
		/// <exception cref="nMailException">
		///	T[oƂ̌MɃG[܂B
		/// <see cref="nMailException.Message"/>ɃG[bZ[WA
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void Connect(int port_no)
		{
			_port = port_no;
			Connect();
		}
		/// <summary>
		/// SMTP T[oƂ̐ڑI
		/// </summary>
		public void Close()
		{
			if(_socket != ErrorSocket) {
				SmtpClose(_socket);
			}
			_socket = ErrorSocket;
			_connect_flag = false;
		}
		/// <summary>
		/// SMTP AUTH F
		/// </summary>
		///	<remarks>
		///	ꎞx~@\gꍇ<see cref="Connect"/>̌ɌĂяo܂B
		///	</remarks>
		/// <exception cref="InvalidOperationException">
		///	ڑԂł͂܂B<see cref="Connect"/>ĂȂAĂяoĂ܂B̃\bhĂяoꍇ(<see cref="Connect"/>ĂяoKv܂BB
		///	</exception>
		/// <exception cref="nMailException">
		///	T[oƂ̌MɃG[܂B
		/// <see cref="nMailException.Message"/>ɃG[bZ[WA
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void Authenticate()
		{
			if(_socket == ErrorSocket) {
				throw new InvalidOperationException();
			}
			_err = SmtpAuthenticate(_socket, _host, _id, _password, _mode);
			if(_err < 0)
			{
				throw new nMailException("Authenticate:" + Options.ErrorMessage, _err);
			}
		}
		/// <summary>
		/// SMTP AUTH F
		/// </summary>
		/// <param name="id_str">[U[ ID</param>
		/// <param name="pass_str">pX[h</param>
		/// <param name="mode">AUTH </param>
		/// <remarks>
		/// AUTH ʂ̐ݒ\Ȓl͉L̒ʂłB
		/// <see cref="AuthPlain"/>  PLAIN gp܂B
		/// <see cref="AuthLogin"/>  LOGIN gp܂B
		/// <see cref="AuthCramMd5"/> CRAM MD5 gp܂B
		/// AuthNotUse ȊO C#  | AVB.NET ł Or ŕw\łB
		/// CRAM MD5LOGINPLAIN ̗D揇ʂŔF؂݂܂B
		/// </remarks>
		/// <exception cref="InvalidOperationException">
		///	ڑԂł͂܂B<see cref="Connect"/>ĂȂAĂяoĂ܂B̃\bhĂяoꍇ(<see cref="Connect"/>ĂяoKv܂BB
		///	</exception>
		/// <exception cref="nMailException">
		///	T[oƂ̌MɃG[܂B
		/// <see cref="nMailException.Message"/>ɃG[bZ[WA
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void Authenticate(string id_str, string pass_str, int mode)
		{
			_id = id_str;
			_password = pass_str;
			_mode = mode;
			Authenticate();
		}
		/// <summary>
		/// SMTP |[gԍłB
		/// </summary>
		/// <value>SMTP |[gԍ</value>
		public int Port {
			get
			{
				return _port;
			}
			set
			{
				_port = value;
			}
		}
		/// <summary>
		/// \PbgnhłB
		/// </summary>
		/// <value>SMTP \Pbgnh</value>
		public int Handle {
			get
			{
				return _socket;
			}
		}
		/// <summary>
		/// SMTP T[ołB
		/// </summary>
		/// <value>SMTP T[o</value>
		public string HostName
		{
			get
			{
				return _host;
			}
			set
			{
				_host = value;
			}
		}
		/// <summary>
		/// SMTP AUTH p̃[U[łB
		/// </summary>
		/// <value>SMTP AUTH [U[</value>
		public string Id
		{
			get
			{
				return _id;
			}
			set
			{
				_id = value;
			}
		}
		/// <summary>
		/// SMTP AUTH p̃pX[hłB
		/// </summary>
		/// <value>SMTP AUTH pX[h</value>
		public string Password
		{
			get
			{
				return _password;
			}
			set
			{
				_password = value;
			}
		}
		/// <summary>
		/// [̈łB
		/// </summary>
		/// <remarks>
		/// ̈ɑMꍇA ',' ŋ؂ă[AhXLqĂB
		/// </remarks>
		/// <value>[ </value>
		public string MailTo
		{
			get
			{
				return _to;
			}
			set
			{
				_to = value;
			}
		}
		/// <summary>
		/// [ CC łB
		/// </summary>
		/// <remarks>
		/// ̈ɑMꍇA ',' ŋ؂ă[AhXLqĂB
		/// </remarks>
		/// <value>[ CC</value>
		public string Cc
		{
			get
			{
				return _cc;
			}
			set
			{
				_cc = value;
			}
		}
		/// <summary>
		/// [ BCC łB
		/// </summary>
		/// <remarks>
		/// ̈ɑMꍇA ',' ŋ؂ă[AhXLqĂB
		/// </remarks>
		/// <value>[ BCC</value>
		public string Bcc
		{
			get
			{
				return _bcc;
			}
			set
			{
				_bcc = value;
			}
		}
		/// <summary>
		/// [̍olłB
		/// </summary>
		/// <value>[ol</value>
		public string From
		{
			get
			{
				return _from;
			}
			set
			{
				_from = value;
			}
		}
		/// <summary>
		/// [̌łB
		/// </summary>
		/// <value>[</value>
		public string Subject
		{
			get
			{
				return _subject;
			}
			set
			{
				_subject = value;
			}
		}
		/// <summary>
		/// [̖{łB
		/// </summary>
		/// <value>[{</value>
		public string Body
		{
			get
			{
				return _body;
			}
			set
			{
				_body = value;
			}
		}
		/// <summary>
		/// [̓Ytt@CłB
		/// </summary>
		/// <remarks>
		/// ̓Ytt@C𑗐MꍇA"," ŋ؂܂B
		/// <see cref="Options.SplitChar"/>ŋ؂蕶ύXł܂B
		/// </remarks>
		/// <value>Ytt@C</value>
		public string FileName
		{
			get
			{
				_filename = String.Join(Convert.ToString(Options.SplitChar), _filename_list);
				return _filename;
			}
			set
			{
				_filename = value;
				if(_filename.Length > 0) 
				{
					_filename_list = _filename.ToString().Split(Options.SplitChar);
				} 
				else 
				{
					_filename_list = null;
				}
			}
		}
		/// <summary>
		/// Ytt@C̔złB
		/// </summary>
		/// <value>Ytt@C</value>
		public string[] FileNameList
		{
			get
			{
				return _filename_list;
			}
			set
			{
				_filename_list = value;
			}
		}
		/// <summary>
		/// [̒ǉwb_łB
		/// </summary>
		/// <remarks>
		/// ̃wb_ǉꍇAC# ł '\r\n'AVisual Basic ł ControlChars.CrLf
		/// ŘAĂB
		/// </remarks>
		/// <value>ǉwb_</value>
		public string Header
		{
			get
			{
				return _header;
			}
			set
			{
				_header = value;
			}
		}
		/// <summary>
		/// [M̃IvVwłB
		/// </summary>
		/// <value>MIvV</value>
		/// <remarks>
		/// <para><see cref="AddDateField"/>MtB[h nMail.DLL Ő܂B</para>
		/// <para><see cref="AddMessageId"/>Message-ID tB[h nMail.DLL Ő܂B</para>
		/// <para><see cref="SuspendAttachmentFile"/>Ytt@CMňꎞx~̈ڂɎw肵܂B</para>
		/// <para><see cref="SuspendNext"/>Ytt@CMňꎞx~̓ڈȍ~Ɏw肵܂B</para>
		///	<para><see cref="FileNameRfc2231"/>RFC2231 œYtt@CGR[h܂B</para>
		/// <para><see cref="EncodeUtf8"/>UTF-8 Ń[GR[h܂iBASE64ŃGR[h܂j</para>
		/// <para>C# ̏ꍇ |AVB.NET ̏ꍇ Or ŕ̎w肪\łB SuspendAttachmentFile  SuspendNext ͓Ɏwł܂B</para>
		/// </remarks>
		public int Flag
		{
			get
			{
				return _flag;
			}
			set
			{
				_flag = value;
			}
		}
		/// <summary>
		/// SMTP AUTH ̎ʂłB
		/// </summary>
		/// <remarks>
		/// <see cref="AuthNotUse"/>  SMTP AUTH ͎gp܂B
		/// <see cref="AuthPlain"/>  PLAIN gp܂B
		/// <see cref="AuthLogin"/>  LOGIN gp܂B
		/// <see cref="AuthCramMd5"/> CRAM MD5 gp܂B
		/// AuthNotUse ȊO C#  | AVisual Basic ł or ŕݒ\łB
		/// CRAM MD5LOGINPLAIN ̏ԂŔF؂݂܂B
		///	ftHgl AuthNotUse łB
		/// </remarks>
		/// <value>M[h</value>
		public int AuthMode
		{
			get
			{
				return _mode;
			}
			set
			{
				_mode = value;
			}
		}
		/// <summary>
		/// [M̃G[ԍłB
		/// </summary>
		/// <value>G[ԍ</value>
		public int ErrorCode
		{
			get
			{
				return _err;
			}
		}
	}
	/// <summary>
	/// Ytt@CۑNX
	/// </summary>
	/// <example>
	/// <para>
	///	ꂽ[f[^ǂݏoAĕۑ
	/// <code lang="cs">
	///	using(nMail.Attachment attach = new nMail.Attachment()) {
	///		try {
	///			attach.Path = @"z:\temp";
	///			// count ͕
	///			for(int no = 0 ; no &lt; count ; no++) {
	///				// Read()  header Ƀwb_{"\r\n"{"{"ǂݏo
	///				string header = Read(no)
	///				attach.Add(header);
	///			}
	///			attach.Save();
	///			// I
	///			MessageBox.Show(attach.Path + " ɓYtt@C " + attach.FileName + " ۑ܂B\r\n\r\n:" + attach.Subject + "\r\n{:\r\n" + attach.Body);
	///		}
	///		catch(nMailException nex) {
	///				if(nex.ErrorCode == nMail.Attachment.ErrorFileOpen) {
	///					MessageBox.Show("Ytt@CI[vł܂B");
	///				} else if(nex.ErrorCode == nMail.Attachment.ErrorInvalidNo) {
	///	                MessageBox.Show("ꂽ[̏ԂȂAYȂt@CĂ܂B")
	///				} else if(nex.ErrorCode == nMail.Attachment.ErrorPartial) {
	///					MessageBox.Show("ꂽ[SđĂ܂");
	///				}
	///			} catch(Exception ex) {
	///				MessageBox.Show(String.Format("G[ bZ[W:{0:s}", ex.Message))
	///			}
	///		}
	///	}
	/// </code>
	/// </para>
	/// <para>
	/// <code lang="vbnet">
	///	' VB.NET 2005 ȍ~̏ꍇAC# Ɠl using gpł܂B
	///	Dim attach As nMail.Attachment = New nMail.Attachment
	///	Try
	///		Dim no As Integer
	///		attach.Path = "z:\temp"
	///		// count ͕
	///		For no = 0 To count - 1
	///			' Read()  header Ƀwb_{ControlChars.CrLf{"{"ǂݏo
	///			string header = Read(no)
	///			attach.Add(header)
	///		Next no
	///		attach.Save()
	///		' I
	///		MessageBox.Show(attach.Path + " ɓYtt@C " + attach.FileName + " ۑ܂B" + ControlChars.CrLf + ControlChars.CrLf + ":" + attach.Subject + ControlChars.CrLf + "{:" + ControlChars.CrLf + attach.Body)
	///	Catch nex As nMail.nMailException
	///		If nex.ErrorCode = nMail.Attachment.ErrorFileOpen Then
	///			MessageBox.Show("Ytt@CI[vł܂B")
	///		ElseIf nex.ErrorCode = nMail.Attachment.ErrorInvalidNo Then
	///			MessageBox.Show("ꂽ[̏ԂȂAYȂt@CĂ܂B")
	///		ElseIf nex.ErrorCode = nMail.Attachment.ErrorPartial Then
	///			MessageBox.Show("ꂽ[SđĂ܂")
	///		End If
	///	Catch ex As Exception
	///		Debug.WriteLine(ex.Message)
	///	Finally
	///		attach.Dispose()
	///	End Try
	/// </code>
	/// </para>
	/// </example>
	public class Attachment : IDisposable
	{
		/// <summary>
		/// wb_̈̃TCYłB
		/// </summary>
		protected const int HeaderSize = 32768;
		/// <summary>
		/// pX̃TCYłB
		/// </summary>
		protected const int MaxPath = 32768;
		/// <summary>
		/// Ytt@CWJpobt@̃TCYłB
		/// </summary>
		protected const int AttachmentTempSize = 400;

		/// <summary>
		/// ꂽYtt@C̏Ԃ܂B
		/// </summary>
		public const int ErrorInvalidNo = -3;
		/// <summary>
		/// Ytt@C쐬ł܂łB
		/// </summary>
		public const int ErrorFileOpen = -5;
		/// <summary>
		/// Ytt@C̓WJIĂ܂B
		/// </summary>
		public const int ErrorPartial = -6;
		/// <summary>
		/// Ytt@CƓ̃t@CtH_ɑ݂܂B
		/// </summary>
		/// <remarks>
		/// <para><see cref="nMail.Options.AlreadyFile"/>  <see cref="nMail.Options.FileAlreadyError"/></para>
		/// <para>ݒ肵A<see cref="Path"/>Ŏw肵tH_ɓYtt@CƓÕt@C</para>
		/// <para>ꍇɂ̃G[܂B</para>
		/// </remarks>
		public const int ErrorFileAlready = -7;
		/// <summary>
		/// mۃG[łB
		/// </summary>
		public const int ErrorMemory = -9;
		/// <summary>
		/// ̑̃G[łB
		/// </summary>
		public const int ErrorEtc = -10;
		/// <summary>
		/// Ytt@C݂͑܂B
		/// </summary>
		public const int NoAttachmentFile = -1;
		/// <summary>
		/// wb_f[^̃Xg
		/// </summary>
		protected ArrayList _header_list;
		/// <summary>
		/// {f[^̃Xg
		/// </summary>
		protected ArrayList _body_list;

		/// <summary>
		/// wb_[TCYłB
		/// </summary>
		protected int _header_size = -1;
		/// <summary>
		/// G[ԍłB
		/// </summary>
		protected int _err;
		/// <summary>
		/// Ytt@CۑpXłB
		/// </summary>
		protected string _path = null;
		/// <summary>
		/// [̌łB
		/// </summary>
		protected StringBuilder _subject;
		/// <summary>
		/// [̑MłB
		/// </summary>
		protected StringBuilder _date;
		/// <summary>
		/// [̍olłB
		/// </summary>
		protected StringBuilder _from;
		/// <summary>
		/// [̃wb_łB
		/// </summary>
		protected StringBuilder _header;
		/// <summary>
		/// [̖{łB
		/// </summary>
		protected StringBuilder _body;
		/// <summary>
		/// WJYtt@CłB
		/// </summary>
		protected StringBuilder _filename;
		/// <summary>
		/// Ytt@C̃XgłB
		/// </summary>
		protected string[] _filename_list = null;
		/// <summary>
		/// t@C ID łB
		/// </summary>
		protected StringBuilder _id;
		/// <summary>
		/// Ytt@CWJpobt@łB
		/// </summary>
		protected byte[] _temp;
		/// <summary>
		/// WJJnǂ̃tOłB
		/// </summary>
		protected bool _attachment_flag = false;
		/// <summary>
		/// Dispose sǂ̃tOłB
		/// </summary>
		private bool _disposed = false;

		[DllImport("nMail.DLL", EntryPoint="NMailAttachmentFileFirst", CharSet=CharSet.Auto)]
		protected static extern int AttachmentFileFirst(byte []Temp, StringBuilder Subject, StringBuilder Date, StringBuilder From, StringBuilder Header, StringBuilder Body, string Path, StringBuilder FileName, string FirstHeader, string FirstBody);

		[DllImport("nMail.DLL", EntryPoint="NMailAttachmentFileNextVB", CharSet=CharSet.Auto)]
		protected static extern int AttachmentFileNextVB(byte []Temp, StringBuilder Subject, StringBuilder Date, StringBuilder From, StringBuilder Header, StringBuilder Body, string Path, StringBuilder FileName, string NextHeader, string NextBody);

		[DllImport("nMail.DLL", EntryPoint="NMailAttachmentFileClose")]
		protected static extern bool AttachmentFileClose(byte []Temp);

		[DllImport("nMail.DLL", EntryPoint="NMailAttachmentFileStatus", CharSet=CharSet.Auto)]
		protected static extern int AttachmentFileStatus(string Header, StringBuilder Id, int Size);

		/// <summary>
		/// <c>Attachment</c>NX̐VKCX^X܂B
		/// </summary>
		public Attachment()
		{
			_header_list = new ArrayList();
			_body_list = new ArrayList();
			_temp = new byte[AttachmentTempSize];
		}
		/// <summary>
		/// 
		/// </summary>
		~Attachment()
		{
			Dispose(false);
		}
		/// <summary>
		/// <see cref="Attachment"/>ɂĎgpĂ邷ׂẴ\[X܂B
		/// </summary>
		public void Dispose()
		{
			Dispose(true);
			GC.SuppressFinalize(this);
		}
		/// <summary>
		/// <see cref="Attachment"/>ɂĎgpĂ邷ׂẴ\[X܂B
		/// </summary>
		/// <param name="disposing">
		/// }l[W\[XƃA}l[W\[X̗ꍇ<c>true</c>B
		/// A}l[W\[Xꍇ<c>false</c>B
		/// </param>
		protected virtual void Dispose(bool disposing)
		{
			if(!_disposed)
			{
				if(disposing)
				{
				}
				if(_attachment_flag)
				{
					AttachmentFileClose(_temp);
					_attachment_flag = false;
				}
				_disposed = true;
			}
		}
		/// <summary>
		/// Ytt@CWJŎgpĂ\[X܂B
		/// </summary>
		public void Close()
		{
			if(_attachment_flag)
			{
				AttachmentFileClose(_temp);
				_attachment_flag = false;
			}
		}
		/// <summary>
		/// wb_i[pobt@̃TCY肵܂B
		/// </summary>
		protected void SetHeaderSize()
		{
			if(_header_size < 0)
			{
				_header_size = Options.HeaderMax;
			}
			if(_header_size <= 0)
			{
				_header_size = HeaderSize;
				Options.HeaderMax = _header_size;
			}
		}
		/// <summary>
		/// [{̍vTCY擾܂B
		/// </summary>
		/// <returns>[{̍vTCY</returns>
		protected int GetBodySize()
		{
			int size = 0;
			string str;

			for(int no = 0 ; no < _header_list.Count ; no++)
			{
				if(no < _body_list.Count)
				{
					str = (string)_body_list[no];
					size += str.Length;
				}
				str = (string)_header_list[no];
				size += str.Length;
			}
			return size;
		}
		/// <summary>
		/// Ytt@CWJĕۑ܂B
		/// </summary>
		/// <exception cref="FormatException">
		///	<see cref="Add"/>ŌƂȂ镶iwb_,{)ǉĂ܂B
		///	</exception>
		/// <exception cref="DirectoryNotFoundException">
		///	<see cref="Path"/>Ŏw肵tH_݂܂B
		/// </exception>
		/// <exception cref="nMailException">
		///	WJɃG[܂B
		/// <see cref="nMailException.Message"/>ɃG[bZ[WA
		/// <see cref="nMailException.ErrorCode"/>ɃG[R[h܂B
		/// </exception>
		public void Save()
		{
			if(_path != null && _path != "") {
				if(!Directory.Exists(_path)) {
					throw new DirectoryNotFoundException(_path);
				}
			}
			if(_header_list.Count != _body_list.Count && _body_list.Count > 0)
			{
				throw new FormatException();
			}
			string read_body;
			string read_header;
			string keep_id = "";
			int id_no;

			SetHeaderSize();
			_subject = new StringBuilder(_header_size);
			_date = new StringBuilder(_header_size);
			_from = new StringBuilder(_header_size);
			_header = new StringBuilder(_header_size);
			_body = new StringBuilder(GetBodySize());
			_filename = new StringBuilder(MaxPath);
			for(int no = 0 ; no < _header_list.Count ; no++)
			{
				if(no < _body_list.Count)
				{
					read_body = (string)_body_list[no];
				}
				else
				{
					read_body = "";
				}
				read_header = (string)_header_list[no];
				if(no == 0)
				{
					id_no = GetId(read_header);
					if(id_no > 1) {
						throw new nMailException("Save", ErrorInvalidNo);
					}
					keep_id = PartId;
					_attachment_flag = true;
					_err = AttachmentFileFirst(_temp, _subject, _date, _from, _header, _body, _path, _filename, read_header, read_body);
				}
				else
				{
					if(GetId(read_header) != no + 1 || keep_id != PartId) {
						throw new nMailException("Save", ErrorInvalidNo);
					}
					_err = AttachmentFileNextVB(_temp, _subject, _date, _from, _header, _body, _path, _filename, read_header, read_body);
				}
				if(_err < 0 && _err != ErrorPartial)
				{
					throw new nMailException("Save", _err);
				}
			}
			AttachmentFileClose(_temp);
			_attachment_flag = false;
		}
		/// <summary>
		/// WJƂȂ镪t@Cf[^Xgɒǉ܂B
		/// </summary>
		/// <param name="header_body">wb_[{{̕</param>
		/// <remarks>
		///	wb_Ɩ{̊Ԃɂ͈s̋sKvłB
		/// </remarks>
		public void Add(string header_body)
		{
			_header_list.Add(header_body);
		}
		/// <summary>
		/// WJƂȂ镪t@Cf[^Xgɒǉ܂B
		/// </summary>
		/// <param name="header">wb_[̕</param>
		/// <param name="body">{̕</param>
		public void Add(string header, string body)
		{
			_header_list.Add(header);
			_body_list.Add(body);
		}
		/// <summary>
		/// t@C ID 擾܂B
		/// </summary>
		/// <param name="header">wb_[̕</param>
		/// <returns><see cref="NoAttachmentFile"/>̏ꍇĂȂYtt@Ct[łB
		/// 1 ȏ̏ꍇAt@C̔ԍƂȂ܂B
		/// </returns>
		public int GetId(string header)
		{
			_id = new StringBuilder(header.Length);
			return AttachmentFileStatus(header, _id, header.Length);
		}

		/// <summary>
		/// 
		/// </summary>
		/// <value>[</value>
		public string Subject
		{
			get
			{
				if(_subject == null)
				{
					return "";
				}
				else
				{
					return _subject.ToString();
				}
			}
		}
		/// <summary>
		/// [̑M̕łB
		/// </summary>
		/// <value>[M</value>
		public string DateString
		{
			get
			{
				if(_date == null)
				{
					return "";
				}
				else
				{
					return _date.ToString();
				}
			}
		}
		/// <summary>
		/// [̍olłB
		/// </summary>
		/// <value>[ol</value>
		public string From
		{
			get
			{
				if(_from == null)
				{
					return "";
				}
				else
				{
					return _from.ToString();
				}
			}
		}
		/// <summary>
		/// [̖{łB
		/// </summary>
		/// <value>[{</value>
		public string Body
		{
			get
			{
				if(_body == null)
				{
					return "";
				}
				else
				{
					return _body.ToString();
				}
			}
		}
		/// <summary>
		/// Ytt@CۑtH_łB
		/// </summary>
		/// <remarks>
		/// ""  null ̏ꍇۑ܂B
		/// </remarks>
		/// <value>Ytt@CۑtH_</value>
		public string Path
		{
			get
			{
				return _path;
			}
			set
			{
				_path = value;
			}
		}
		/// <summary>
		/// t@C ID łB
		/// </summary>
		/// <value>t@C ID</value>
		public string PartId
		{
			get
			{
				if(_id == null)
				{
					return "";
				}
				else
				{
					return _id.ToString();
				}
			}
		}
		/// <summary>
		/// Ytt@CłB
		/// </summary>
		/// <remarks>
		/// ̓Ytt@CꍇA"," ŋ؂Ċi[܂B
		/// <see cref="Options.SplitChar"/>ŋ؂蕶ύXł܂B
		/// </remarks>
		/// <value>Ytt@C</value>
		public string FileName
		{
			get
			{
				if(_filename == null)
				{
					return "";
				}
				else
				{
					return _filename.ToString();
				}
			}
		}
		/// <summary>
		/// Ytt@C̔złB
		/// </summary>
		/// <value>Ytt@C</value>
		public string[] FileNameList
		{
			get
			{
				if(_filename.Length > 0) 
				{
					_filename_list = _filename.ToString().Split(Options.SplitChar);
				} 
				else 
				{
					_filename_list = null;
				}
				return _filename_list;
			}
		}
		/// <summary>
		/// G[ԍ
		/// </summary>
		/// <value>G[ԍ</value>
		public int ErrorCode
		{
			get
			{
				return _err;
			}
		}
	}
	/// <summary>
	/// nMail.DLL ݒpNX
	/// </summary>
	public class Options
	{
		/// <summary>
		/// <c>Options</c>NX̐VKCX^X܂B
		/// </summary>
		public Options()
		{
		}
		/// <summary>
		/// 
		/// </summary>
		protected const int MessageSize = 32768;

		/// <summary>
		/// IvVF^CAEg
		/// </summary>
		protected const int OptionTimeout = 0;
		/// <summary>
		/// IvVFwb_TCY
		/// </summary>
		protected const int OptionHeaderMax = 1;
		/// <summary>
		/// IvVF{TCY
		/// </summary>
		protected const int OptionBodyMax = 2;
		/// <summary>
		/// IvVF㏑[h
		/// </summary>
		protected const int OptionAlreadyFile = 3;
		/// <summary>
		/// IvVFfobN[h
		/// </summary>
		protected const int OptionDebugMode = 4;
		/// <summary>
		/// IvVFڑ^CAEg
		/// </summary>
		protected const int OptionConnectTimeout = 5;
		/// <summary>
		/// IvVF؂蕶
		/// </summary>
		protected const int OptionSplitChar = 6;
		/// <summary>
		/// IvVFꎞx~TCY
		/// </summary>
		protected const int OptionSuspendSize = 7;
		/// <summary>
		/// IvVFSleep 
		/// </summary>
		protected const int OptionSleepTime = 8;
		/// <summary>
		/// IvVFtB[hTCY
		/// </summary>
		protected const int OptionFieldMax = 9;

		/// <summary>
		/// t@C㏑܂B
		/// </summary>
		public const int FileOverwrite = 1;
		/// <summary>
		/// t@C̖(gq̑O)ɐǉĕۑ܂B
		/// "file.dat" ݂ꍇA"file1.dat" ƂOŕۑ܂B
		/// </summary>
		public const int FileRename = 2;
		/// <summary>
		/// t@C쐬G[Ƃ܂B
		/// </summary>
		public const int FileAlreadyError = 3;

		/// <summary>
		/// 
		/// </summary>
		protected const int MessageError = 0;
		/// <summary>
		/// 
		/// </summary>
		protected const int MessageDebug = 1;

		/// <summary>
		/// fobN[hLłB
		/// </summary>
		public const int DebugStart = 1;
		/// <summary>
		/// fobN[hłB
		/// </summary>
		public const int DebugEnd = 0;

		/// <summary>
		/// ڑ^CAEgLłB
		/// </summary>
		public const int ConnectTimeoutOn = 1;
		/// <summary>
		/// ڑ^CAEgłB
		/// </summary>
		public const int ConnectTimeoutOff = 1;

		[DllImport("nMail.DLL", EntryPoint="NMailGetVersion")]
		protected static extern int GetVersion();

		[DllImport("nMail.DLL", EntryPoint="NMailGetOption")]
		protected static extern int GetOption(int option);

		[DllImport("nMail.DLL", EntryPoint="NMailSetOption")]
		protected static extern int SetOption(int option, int value);

		[DllImport("nMail.DLL", EntryPoint="NMailGetMessage", CharSet=CharSet.Auto)]
		protected static extern void GetMessage(int Type, StringBuilder Message, int Size);

		[DllImport("nMail.DLL", EntryPoint="NMailGetSuspendNumber", CharSet=CharSet.Auto)]
		protected static extern int GetSuspendNumber(string Path);

		/// <summary>
		/// fobN[hJn܂B
		/// </summary>
		/// <remarks>
		/// <see cref="EndDebug"/>Ăяo <see cref="DebugMessage"/>
		/// QƂ邱ƂɂăT[oƂ̌M擾ł܂B
		/// </remarks>
		public static void StartDebug()
		{
			SetOption(OptionDebugMode, DebugStart);
		}

		/// <summary>
		/// fobN[hI܂B
		/// </summary>
		/// <remarks>
		/// Ăяo <see cref="DebugMessage"/> QƂ邱ƂɂăT[o
		/// Ƃ̌M擾ł܂B
		/// </remarks>
		public static void EndDebug()
		{
			SetOption(OptionDebugMode, DebugEnd);
		}

		/// <summary>
		/// ڑ^CAEgݒLɂ܂B
		/// </summary>
		public static void EnableConnectTimeout()
		{
			SetOption(OptionConnectTimeout, ConnectTimeoutOn);
		}

		/// <summary>
		/// ڑ^CAEgݒ𖳌ɂ܂B
		/// </summary>
		public static void DisableConnectTimeout()
		{
			SetOption(OptionConnectTimeout, ConnectTimeoutOff);
		}
		/// <summary>
		/// w肳ꂽt@CYt[𑗐Mꍇ̋x~񐔂𓾂
		/// </summary>
		/// <param name="file_name">Ytt@C</param>
		/// <exception cref="FileNotFoundException">
		/// file_name Őݒ肳Ăt@C݂܂B
		/// </exception>
		/// <value>w肳ꂽt@CYt[𑗐Mꍇ̋x~񐔂𓾂</value>
		public static int SuspendCount(String file_name)
		{
			if(!File.Exists(file_name)) {
				throw new FileNotFoundException(file_name);
			}
			return GetSuspendNumber(file_name);
		}

		/// <summary>
		/// o[W̐lłB
		/// </summary>
		/// <remarks>
		/// nMail.DLL ̃o[W̐lłB
		/// Version 1.23 ̏ꍇ 123 ƂȂ܂B
		/// </remarks>
		/// <value>o[Wl</value>
		public static int VersionInt
		{
			get
			{
				return GetVersion();
			}
		}
		/// <summary>
		/// o[W̕łB
		/// </summary>
		/// <remarks>
		/// nMail.DLL ̃o[W̕łB
		/// Version 1.23 ̏ꍇ "1.23" ƂȂ܂B
		/// </remarks>
		/// <value>o[W</value>
		public static string Version
		{
			get
			{
				string str;
				int ver = GetVersion();
				str = String.Format("{0:d}.{1:d}", ver / 100, ver % 100);
				return str;
			}
		}
		/// <summary>
		/// G[bZ[WłB
		/// </summary>
		/// <remarks>
		/// G[ɃT[oԂĂG[bZ[WłB
		/// </remarks>
		/// <value>G[bZ[W</value>
		public static string ErrorMessage
		{
			get
			{
				StringBuilder message;
				message = new StringBuilder(MessageSize);
				GetMessage(MessageError, message, MessageSize);
				return message.ToString();
			}
		}
		/// <summary>
		/// fobNpłB
		/// </summary>
		/// <remarks>
		/// <see cref="StartDebug"/>ĂяoɃ[̑MsA
		/// <see cref="EndDebug"/>Ăяoɂ̃vpeBQƂ邱
		/// ɂăT[oƂ̌M擾邱Ƃł܂B
		/// </remarks>
		/// <value>fobNp</value>
		public static string DebugMessage
		{
			get
			{
				StringBuilder message;
				message = new StringBuilder(MessageSize);
				GetMessage(MessageDebug, message, MessageSize);
				return message.ToString();
			}
		}
		/// <summary>
		/// ^CAEglłB
		/// </summary>
		/// <remarks>
		/// ̐ݒl蒷ԃT[o牞ꍇA
		/// ^CAEgG[ƂďԂ܂B
		/// Pʂ ms łB
		/// ڑ̃^CAEg͒ʏ͖łB
		/// LɂꍇA<see cref="EnableConnectTimeout"/>
		/// ĂяoĂB
		/// </remarks>
		/// <value>^CAEgl</value>
		public static int Timeout
		{
			get
			{
				return GetOption(OptionTimeout);
			}
			set
			{
				SetOption(OptionTimeout, value);
			}
		}
		/// <summary>
		/// wb_obt@TCYłB
		/// </summary>
		/// <remarks>
		/// [MYtt@CWJɃwb_f[^i[
		/// obt@̃TCYłB
		/// {I<see cref="Pop3"/>NXŃ[̎MsꍇA
		/// obt@TCY̐ݒs܂̂ŁÃvpeB
		/// gpKv͂܂B
		/// </remarks>
		/// <value>wb_obt@TCY</value>
		public static int HeaderMax
		{
			get
			{
				return GetOption(OptionHeaderMax);
			}
			set
			{
				SetOption(OptionHeaderMax, value);
			}
		}
		/// <summary>
		/// {obt@TCYłB
		/// </summary>
		/// <remarks>
		/// [MYtt@CWJɃwb_f[^i[
		/// {̃TCYłB
		/// {I<see cref="Pop3"/>NXŃ[̎MsꍇA
		/// [TCYɉobt@TCY̎ws܂̂ŁA
		/// ̃vpeBgpKv͂܂B
		/// </remarks>
		/// <value>{obt@TCY</value>
		public static int BodyMax
		{
			get
			{
				return GetOption(OptionBodyMax);
			}
			set
			{
				SetOption(OptionBodyMax, value);
			}
		}
		/// <summary>
		/// Ytt@CۑɁAwtH_ɓt@Cꍇ̏@łB
		/// </summary>
		/// <remarks>
		/// <see cref="FileOverwrite"/>t@C㏑܂B
		/// <see cref="FileRename"/>t@C̖(gq̑O)ɐǉĕۑ܂B
		/// <see cref="FileAlreadyError"/>t@C쐬G[Ƃ܂B
		/// </remarks>
		/// <value>Ytt@Cۑ̓t@C@</value>
		public static int AlreadyFile
		{
			get
			{
				return GetOption(OptionAlreadyFile);
			}
			set
			{
				SetOption(OptionAlreadyFile, value);
			}
		}
		/// <summary>
		/// fobN[h
		/// </summary>
		/// <remarks>
		/// <see cref="DebugStart"/>fobN[hLłB
		/// <see cref="DebugEnd"/>fobN[hłB
		/// </remarks>
		/// <value>fobN[h</value>
		public static int DebugMode
		{
			get
			{
				return GetOption(OptionDebugMode);
			}
			set
			{
				SetOption(OptionDebugMode, value);
			}
		}
		/// <summary>
		/// T[oڑ̃^CAEglłB
		/// </summary>
		/// <remarks>
		/// <see cref="ConnectTimeoutOn"/>ڑ^CAEgLłB
		/// <see cref="ConnectTimeoutOff"/>ڑ^CAEgłB
		/// </remarks>
		/// <value>T[oڑ̃^CAEgl</value>
		public static int ConnectTimeout
		{
			get
			{
				return GetOption(OptionConnectTimeout);
			}
			set
			{
				SetOption(OptionConnectTimeout, value);
			}
		}
		/// <summary>
		/// Ytt@C̋؂蕶łB
		/// </summary>
		/// <remarks>
		/// Ytt@Cꍇ̋؂蕶łB
		///	ftHgl , łB
		/// </remarks>
		/// <value>Ytt@C؂蕶</value>
		public static char SplitChar
		{
			get
			{
				return (char)GetOption(OptionSplitChar);
			}
			set
			{
				SetOption(OptionSplitChar, (int)value);
			}
		}
		/// <summary>
		/// M̍ۂɈU߂f[^TCYłB
		/// </summary>
		/// <remarks>
		/// Ytt@CꍇAŎw肵TCỸf[^
		/// MƁAU߂܂B
		/// </remarks>
		/// <value>M̍ۂɈU߂f[^TCY</value>
		public static int SuspendSize
		{
			get
			{
				return GetOption(OptionSuspendSize);
			}
			set
			{
				SetOption(OptionSuspendSize, value);
			}
		}
		/// <summary>
		/// T[o̕ԓ҂̍ۂɓ Sleep() ̎ԂłB
		/// </summary>
		/// <value>T[o̕ԓ҂̍ۂɓ Sleep() ̎</value>
		public static int SleepTime
		{
			get
			{
				return GetOption(OptionSleepTime);
			}
			set
			{
				SetOption(OptionSleepTime, value);
			}
		}
		/// <summary>
		/// tB[hobt@̃TCYłB
		/// </summary>
		/// <value>tB[hobt@̃TCY</value>
		public static int FieldMax
		{
			get
			{
				return GetOption(OptionFieldMax);
			}
			set
			{
				SetOption(OptionFieldMax, value);
			}
		}
	}
}

/**
	DLL 錾

	[DllImport("nMail.DLL", EntryPoint="NMailInitializeWinSock")]
	protected static extern bool NMailInitializeWinSock();

	[DllImport("nMail.DLL", EntryPoint="NMailEndWinSock")]
	protected static extern bool NMailEndWinSock();

	[DllImport("nMail.DLL", EntryPoint="NMailPop3Connect", CharSet=CharSet.Auto)]
	protected static extern int NMailPop3Connect(string Host);

	[DllImport("nMail.DLL", EntryPoint="NMailPop3ConnectPortNo", CharSet=CharSet.Auto)]
	protected static extern int NMailPop3ConnectPortNo(string Host, int Port);

	[DllImport("nMail.DLL", EntryPoint="NMailPop3Authenticate", CharSet=CharSet.Auto)]
	protected static extern int NMailPop3Authenticate(int Socket, string Id, string Pass, bool APopFlag);

	[DllImport("nMail.DLL", EntryPoint="NMailPop3Close")]
	protected static extern int NMailPop3Close(int Socket);

	[DllImport("nMail.DLL", EntryPoint="NMailPop3GetMailStatus", CharSet=CharSet.Auto)]
	protected static extern int NMailPop3GetMailStatus(int Socket, int No, StringBuilder Subject, StringBuilder Date, StringBuilder From, StringBuilder Header, bool SizeFlag);

	[DllImport("nMail.DLL", EntryPoint="NMailPop3GetMailSize")]
	protected static extern int NMailPop3GetMailSize(int Socket, int No);

	[DllImport("nMail.DLL", EntryPoint="NMailPop3GetMail", CharSet=CharSet.Auto)]
	protected static extern int NMailPop3GetMail(int Socket, int No, StringBuilder Subject, StringBuilder Date, StringBuilder From, StringBuilder Header, StringBuilder Body, string Path, StringBuilder FileName);

	[DllImport("nMail.DLL", EntryPoint="NMailPop3GetMailPartial", CharSet=CharSet.Auto)]
	protected static extern int NMailPop3GetMailPartial(int Socket, int No, StringBuilder Subject, StringBuilder Date, StringBuilder From, StringBuilder Header, StringBuilder Body, string Path, StringBuilder FileName);

	[DllImport("nMail.DLL", EntryPoint="NMailPop3GetMailEx", CharSet=CharSet.Auto)]
	protected static extern int NMailPop3GetMailEx(int Socket, int No, StringBuilder Subject, StringBuilder Date, StringBuilder From, StringBuilder Header, StringBuilder Body, string Path, StringBuilder FileName, BYTE Temp[], int Flag);

	[DllImport("nMail.DLL", EntryPoint="NMailPop3DeleteMail")]
	protected static extern int NMailPop3DeleteMail(int Socket, int No);

	[DllImport("nMail.DLL", EntryPoint="NMailPop3GetAttachmentFileStatus"), CHarSet=CharSet.Auto]
	protected static extern int NMailPop3GetAttachmentFileStatus(int Socket, int No, StringBuilder Id, int Max);

	[DllImport("nMail.DLL", EntryPoint="NMailPop3GetUidl"), CHarSet=CharSet.Auto]
	protected static extern int NMailPop3GetUidl(int Socket, int No, StringBuilder Id, int Max);

	[DllImport("nMail.DLL", EntryPoint="NMailSmtpSendMail", CharSet=CharSet.Auto)]
	protected static extern int NMailSmtpSendMail(String HostName, String To, String Cc, String Bcc, String From, String Subject, String Body, String Header, String Path, int Flag);

	[DllImport("nMail.DLL", EntryPoint="NMailSmtpSendMailPortNo", CharSet=CharSet.Auto)]
	protected static extern int NMailSmtpSendMailPortNo(String HostName, String To, String Cc, String Bcc, String From, String Subject, String Body, String Header, String Path, int Flag, int PortNo);

	[DllImport("nMail.DLL", EntryPoint="NMailSmtpConnect", CharSet=CharSet.Auto)]
	protected static extern int NMailSmtpConnect(string Host);

	[DllImport("nMail.DLL", EntryPoint="NMailSmtpConnectPortNo", CharSet=CharSet.Auto)]
	protected static extern int NMailSmtpConnectPortNo(string Host, int PortNo);

	[DllImport("nMail.DLL", EntryPoint="NMailSmtpAuthenticate", CharSet=CharSet.Auto)]
	protected static extern int NMailSmtpAuthenticate(int Socket, string HostName, string Id, string Pass, int Mode);

	[DllImport("nMail.DLL", EntryPoint="NMailSmtpSendMailEx", CharSet=CharSet.Auto)]
	protected static extern int NMailSmtpSendMailEx(int Socket, string To, string Cc, string Bcc, string From, string Subject, String Body, String Header, String Path, BYTE Temp[], int Flag);

	[DllImport("nMail.DLL", EntryPoint="NMailSmtpClose")]
	protected static extern bool NMailSmtpClose(int Socket);

	[DllImport("nMail.DLL", EntryPoint="NMailGetHeaderField"), CharSet=CharSet.Auto]
	protected static extern int NMailGetHeaderField(StringBuilder Field, string Header, string Name, int Size);

	[DllImport("nMail.DLL", EntryPoint="NMailAttachmentFileFirst"), CharSet=CharSet.Auto]
	protected static extern int NMailAttachmentFileFirst(BYTE Temp[], StringBuilder Subject, StringBuilder Date, StringBuilder From, StringBuilder Header, StringBuilder Body, string Path, StringBuilder FileName, string FirstHeader, string FirstBody);

	[DllImport("nMail.DLL", EntryPoint="NMailAttachmentFileNext"), CharSet=CharSet.Auto]
	protected static extern int NMailAttachmentFileNext(BYTE Temp[], string NextHeader, string NextBody);

	[DllImport("nMail.DLL", EntryPoint="NMailAttachmentFileClose")]
	protected static extern bool NMailAttachmentFileClose(BYTE Temp[]);

	[DllImport("nMail.DLL", EntryPoint="NMailAttachmentFileStatus"), CharSet=CharSet.Auto]
	protected static extern int NMailAttachmentFileStatus(string Header, StringBuilder Id, int Size);

	[DllImport("nMail.DLL", EntryPoint="NMailGetVersion")]
	protected static extern int NMailGetVersion();

	[DllImport("nMail.DLL", EntryPoint="NMailGetOption")]
	protected static extern int NMailGetOption(int Option);

	[DllImport("nMail.DLL", EntryPoint="NMailSetOption")]
	protected static extern int NMailSetOption(int Option, int Value);

	[DllImport("nMail.DLL", EntryPoint="NMailGetMessage", CharSet=CharSet.Auto)]
	protected static extern void NMailGetMessage(int Type, StringBuilder Message, int Size);

	[DllImport("nMail.DLL", EntryPoint="NMailGetSuspendNumber", CharSet=CharSet.Auto)]
	protected static extern void NMailGetSuspendNumber(string Path);
**/

